#if !defined(AFX_ADDFLOWVIEW_H__9340A4BE_6364_48C0_B158_FF3B6FA4E3CE__INCLUDED_)
#define AFX_ADDFLOWVIEW_H__9340A4BE_6364_48C0_B158_FF3B6FA4E3CE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AddFlow\addflow.h"
#include "Domain\DefWorkitem.h"
#include "Domain\Maquina.h"
#include "ViewManager.h"
#include "ViewReceiverBase.h"
#include "AddFlow\Link.h"
#include "AddFlow\Links.h"
#include "AddFlow\Node.h"
#include "AddFlow\Nodes.h"
#include "AddFlow\Picture.h"
#include "MainFrm.h"

/////////////////////////////////////////////////////////////////////////////
// CAddFlowView window

class CAddFlowView : public CView, public CViewReceiverBase {
// Construction
protected:
	CAddFlowView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CAddFlowView)

public:
	//{{AFX_DATA(CAddFlowView)
	CAddFlow m_AddFlow;
	//}}AFX_DATA
// Attributes
	
	CToolBar24 m_wndToolBar;
	HCURSOR	m_hCursor;

private:
	BOOL m_bAddFlowInit;
	BOOL m_bShowTrans;
	BOOL m_bShowGrid;
	CMaquina* m_objMaquina;
	CDefWorkitem* m_objWki;

	CMainFrame* m_pMainFrame;

	/*CPictureHolder picTelIdle;
	CPictureHolder picMoreDigits;
	CPictureHolder picDial;*/

// Operations
public:
	void SetWorkitem(CDefWorkitem* objWki);
	void RefreshDiagrama();
	bool UpdateCurrentDiagram();

	BOOL OnDataUpdate(CViewCommand*);
	bool UpdateWorkitem();

private:
	void DeleteAfNode(CNode* afNode);
	CLink AddLink(CNode* afNodeOrg, CNode* afNodeDst);
	CNode FindNodeByUserData(long);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAddFlowView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CAddFlowView();

	// Generated message map functions
protected:
	//{{AFX_MSG(CAddFlowView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnButtonAddEstado();
	afx_msg void OnButtonEditEstado();
	afx_msg void OnButtonRemoveEstado();
	afx_msg void OnButtonEditTransicion();
	afx_msg void OnButtonRemoveTransicion();
	afx_msg void OnButtonZoomIn();
	afx_msg void OnButtonZoomOut();
	afx_msg void OnButtonToggleGrid();
	afx_msg void OnButtonShowTrans();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnDestroy();
	afx_msg void OnMouseDownAddflow(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpAddflow(short Button, short Shift, long x, long y);
	afx_msg void OnMouseMoveAddflow(short Button, short Shift, long x, long y);
	afx_msg void OnMouseDblClick();
	afx_msg void OnKeyDown(short* KeyCode, short Shift);
	afx_msg BOOL OnToolTipNotify(UINT id, NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ADDFLOWVIEW_H__9340A4BE_6364_48C0_B158_FF3B6FA4E3CE__INCLUDED_)
