#include "stdafx.h"
#include "compintdesigner.h"
#include "DlgEstado.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgEstado dialog


CDlgEstado::CDlgEstado(CWnd* pParent /*=NULL*/)
	: cdxCDynamicDialog(CDlgEstado::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgEstado)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgEstado::DoDataExchange(CDataExchange* pDX) {
	cdxCDynamicDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgEstado)
	DDX_Control(pDX, IDC_CHECK_INITIAL, m_chkInitial);
	DDX_Control(pDX, IDC_TAB1, m_tabCtrl);
	DDX_Control(pDX, IDC_EDIT_ESTADO_NOMBRE, m_edtNombre);
	DDX_Control(pDX, IDC_EDIT_ESTADO_DESCRIPCION, m_edtDescripcion);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDOK, m_btnOk);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgEstado, cdxCDynamicDialog)
	//{{AFX_MSG_MAP(CDlgEstado)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DYNAMIC_MAP(CDlgEstado, cdxCDynamicDialog)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_FRAME, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_PICTURE, mdRepos, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_EDIT_ESTADO_NOMBRE, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_CHECK_INITIAL, mdRepos, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_EDIT_ESTADO_DESCRIPCION, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_TAB1, mdResize, mdResize)
	/*DYNAMIC_MAP_ENTRY(IDC_COMBO_IUFF_VALUE_METODO, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_EDIT_IUFF_VALUE_TEXT, mdResize, mdNone)*/

	DYNAMIC_MAP_ENTRY(IDOK, mdRepos, mdRepos)
	DYNAMIC_MAP_ENTRY(IDCANCEL, mdRepos, mdRepos)
END_DYNAMIC_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgEstado message handlers

BOOL CDlgEstado::OnInitDialog() {
	cdxCDynamicDialog::OnInitDialog();

	m_btnOk.SetIcon(IDI_ICON_ACCEPT);
	m_btnCancel.SetIcon(IDI_ICON_CANCEL);
	m_edtNombre.SetWindowText(m_objEstado->GetID());
	m_edtDescripcion.SetWindowText(m_objEstado->GetDescripcion());
	if(m_objEstado->IsInitial()) {
		m_chkInitial.SetCheck(BST_CHECKED);
	}
	else {
		m_chkInitial.SetCheck(BST_UNCHECKED);
	}
	
	// Setup the tab control
	int nPageID = 0;
	m_tabOnEntry.SetEstado(m_objEstado);
	m_tabOnEntry.Create(IDD_TAB_EST_ONENTRY, this);
	m_tabCtrl.AddSSLPage(_T("On Entry"), nPageID++, &m_tabOnEntry);

	m_tabOnExit.SetEstado(m_objEstado);
	m_tabOnExit.Create(IDD_TAB_EST_ONEXIT, this);
	m_tabCtrl.AddSSLPage(_T("On Exit"), nPageID++, &m_tabOnExit);

	m_tabTActions.SetEstado(m_objEstado);
	m_tabTActions.Create(IDD_TAB_EST_TACTIONS, this);
	m_tabCtrl.AddSSLPage(_T("Timed Actions"), nPageID++, &m_tabTActions);

	CenterWindow();
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDlgEstado::OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult) {
	*pResult = 0;
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDlgEstado::OnOK() {
	CString strData;

	if(m_chkInitial.GetCheck() == BST_CHECKED) {
		m_objEstado->SetInitial(TRUE);
	}
	else {
		m_objEstado->SetInitial(FALSE);
	}

	m_edtNombre.GetWindowText(strData);
	m_objEstado->SetID(strData);
	m_edtDescripcion.GetWindowText(strData);
	m_objEstado->SetDescripcion(strData);

	m_tabOnEntry.UpdateEstado();
	m_tabOnExit.UpdateEstado();
	m_tabTActions.UpdateEstado();

	cdxCDynamicDialog::OnOK();
}


/////////////////////////////////////////////////////////////////////////////
// 
void CDlgEstado::OnCancel() {
	cdxCDynamicDialog::OnCancel();
}
