#include "stdafx.h"
#include "compintdesigner.h"
#include "DlgTransicion.h"
#include "Domain\Globales.h"
#include "Domain\Metodo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgTransicion dialog

CDlgTransicion::CDlgTransicion(CWnd* pParent /*=NULL*/)
	: cdxCDynamicDialog(CDlgTransicion::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgTransicion)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_objTran = NULL;
	ZeroMemory(&m_lastRect, sizeof(RECT));
}


void CDlgTransicion::DoDataExchange(CDataExchange* pDX) {
	cdxCDynamicDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgTransicion)
	DDX_Control(pDX, IDC_EDIT_TRAN_DESTINATION, m_edtDestination);
	DDX_Control(pDX, IDC_EDIT_TRAN_DESCRIPTION, m_edtDescription);
	DDX_Control(pDX, IDC_CBO_TRAN_ACTION, m_cboAction);
	DDX_Control(pDX, IDC_TAB1, m_tabCtrl);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDOK, m_btnOk);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgTransicion, cdxCDynamicDialog)
	//{{AFX_MSG_MAP(CDlgTransicion)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnSelchangeTab)
	ON_WM_SIZE()
	//ON_WM_SIZING()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DYNAMIC_MAP(CDlgTransicion, cdxCDynamicDialog)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_FRAME, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_PICTURE, mdRepos, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_CBO_TRAN_ACTION, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_EDIT_TRAN_DESCRIPTION, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_EDIT_TRAN_DESTINATION, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_TAB1, mdResize, mdResize)
	/*DYNAMIC_MAP_ENTRY(IDC_COMBO_IUFF_VALUE_METODO, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_EDIT_IUFF_VALUE_TEXT, mdResize, mdNone)*/

	DYNAMIC_MAP_ENTRY(IDOK, mdRepos, mdRepos)
	DYNAMIC_MAP_ENTRY(IDCANCEL, mdRepos, mdRepos)
END_DYNAMIC_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgTransicion message handlers
BOOL CDlgTransicion::OnInitDialog() {
	cdxCDynamicDialog::OnInitDialog();

	m_btnOk.SetIcon(IDI_ICON_ACCEPT);
	m_btnCancel.SetIcon(IDI_ICON_CANCEL);
	// Agrego los mtodos del workitem al combo de acciones
	CMyMapIterador<CMetodo*>* iterador =  m_objWki->GetMetodos(); 
	if(iterador->begin()) {
		while(*iterador) {
			CMetodo* oMet = (*iterador)++;
			m_cboAction.AddString(oMet->GetNombre());
		}
	}
	delete iterador;
	m_cboAction.AddString(_T("noevent"));
	m_cboAction.AddString(_T("accept"));
	m_cboAction.AddString(_T("refuse"));

	m_cboAction.SetWindowText(m_objTran->GetNombre());
	m_edtDescription.SetWindowText(m_objTran->GetDescripcion());
	if(m_objTran->GetDestino()) {
		m_edtDestination.SetWindowText(m_objTran->GetDestino()->GetID());
	}
	m_edtDestination.EnableWindow(FALSE);
	// Setup the tab control
	int nPageID = 0;
	m_tabCondition.SetTransicion(m_objTran);
	m_tabCondition.Create(IDD_TAB_TRAN_COND, this);
	m_tabCtrl.AddSSLPage(_T("Condition"), nPageID++, &m_tabCondition);

	m_tabAction.SetTransicion(m_objTran);
	m_tabAction.Create(IDD_TAB_TRAN_ACTION, this);
	m_tabCtrl.AddSSLPage(_T("Action"), nPageID++, &m_tabAction);

	CenterWindow();
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

//////////////////////////////////////////////////////////////////////////
///
void CDlgTransicion::OnSize(UINT nType, int cx, int cy) {
	if(::IsWindow(m_tabCtrl.m_hWnd)) {
		m_tabCtrl.SendMessage(WM_SIZE, nType, MAKELONG(cx,cy));
	}
	cdxCDynamicDialog::OnSize(nType, cx, cy);
}

/*//////////////////////////////////////////////////////////////////////////
///
void CDlgTransicion::OnSizing(UINT nSide, LPRECT lpRect) {
	SHORT sKeyState = GetKeyState(VK_CONTROL);

	if(sKeyState & 0x8000) {
		if(m_lastRect.bottom > lpRect->bottom) {
			lpRect->top += 1;
		}
		else {
			lpRect->top -= 1;
		}
		if(m_lastRect.right > lpRect->right) {
			lpRect->left += 1;
		}
		else {
			lpRect->left -= 1;
		}
		m_lastRect = *lpRect;
	}
	cdxCDynamicDialog::OnSizing(nSide, lpRect);
}*/

/////////////////////////////////////////////////////////////////////////////
// 
void CDlgTransicion::OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult) {
	*pResult = 0;
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDlgTransicion::OnOK() {
	CString strData;

	m_cboAction.GetWindowText(strData);
	m_objTran->SetNombre(strData);
	m_edtDescription.GetWindowText(strData);
	m_objTran->SetDescripcion(strData);

	m_tabCondition.UpdateTransicion();
	m_tabAction.UpdateTransicion();

	cdxCDynamicDialog::OnOK();
}


/////////////////////////////////////////////////////////////////////////////
// 
void CDlgTransicion::OnCancel() {
	cdxCDynamicDialog::OnCancel();
}
