#include "stdafx.h"
#include "compintdesigner.h"
#include "DlgWkiEventoMWIuff.h"
#include "Domain\Configuracion.h"
#include "Domain\Globales.h"
#include "Domain\ScintillaWrapper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormWkiEventoMWIuff

CDlgWkiEventoMWIuff::CDlgWkiEventoMWIuff(CWnd* pParent /*=NULL*/)
	: cdxCDynamicDialog(CDlgWkiEventoMWIuff::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgWkiEventoMWIuff)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_objIuff = NULL;
}


void CDlgWkiEventoMWIuff::DoDataExchange(CDataExchange* pDX) {
	cdxCDynamicDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgWkiEventoMWIuff)
	DDX_Control(pDX, IDC_EDIT_IUFF_VALUE_TEXT, m_edtText);
	DDX_Control(pDX, IDC_EDIT_IUFF_NAME, m_edtName);
	DDX_Control(pDX, IDC_COMBO_IUFF_VALUE_METODO, m_cboMetodo);
	DDX_Control(pDX, IDC_COMBO_IUFF_TYPE, m_cboType);
	DDX_Control(pDX, IDC_CHECK_PERSIST, m_chkPersist);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDOK, m_btnOk);
	DDX_Control(pDX, IDC_SCINTILLACTRL_IUFF_CODE, m_ctrlCode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgWkiEventoMWIuff, cdxCDynamicDialog)
	//{{AFX_MSG_MAP(CDlgWkiEventoMWIuff)
	ON_CBN_SELCHANGE(IDC_COMBO_IUFF_TYPE, OnSelchangeCombo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BEGIN_DYNAMIC_MAP(CDlgWkiEventoMWIuff, cdxCDynamicDialog)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_FRAME, mdResize, mdResize)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_PICTURE_IUFF, mdRepos, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_EDIT_IUFF_NAME, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_COMBO_IUFF_TYPE, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_COMBO_IUFF_VALUE_METODO, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_EDIT_IUFF_VALUE_TEXT, mdResize, mdNone)

	DYNAMIC_MAP_ENTRY(IDOK, mdRepos, mdRepos)
	DYNAMIC_MAP_ENTRY(IDCANCEL, mdRepos, mdRepos)
END_DYNAMIC_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgWkiEventoMWIuff message handlers

/////////////////////////////////////////////////////////////////////////////
// CDlgDial message handlers
BOOL CDlgWkiEventoMWIuff::OnInitDialog() {
	cdxCDynamicDialog::OnInitDialog();

	AddSzOleControl(&m_ctrlCode, mdResize, mdResize);

	m_btnOk.SetIcon(IDI_ICON_ACCEPT);
	m_btnCancel.SetIcon(IDI_ICON_CANCEL);
	CScintillaWrapper objWrap(&m_ctrlCode);
	objWrap.Init("CDlgWkiEventoMWIuff");

	m_edtName.SetWindowText(m_objIuff->GetNombre());
	
	m_cboType.AddString("iuff");
	m_cboType.AddString("text");
	m_cboType.AddString("param");
	m_cboType.AddString("function");
	m_cboType.AddString("code");

	CStringArray arrFuncs;
	g_objConfig->GetIuffFunctions(arrFuncs);
	for(int i = 0; i < arrFuncs.GetSize(); i++) {
		m_cboMetodo.AddString(arrFuncs.GetAt(i));
	}

	m_edtText.ShowWindow(SW_HIDE);
	m_cboMetodo.ShowWindow(SW_HIDE);
	m_ctrlCode.ShowWindow(SW_HIDE);
	m_ctrlCode.BringWindowToTop();

	m_cboMetodo.GetWindowRect(&m_curPos);
	ScreenToClient(&m_curPos);

	m_edtText.MoveWindow(m_curPos);
	m_ctrlCode.MoveWindow(m_curPos.left, m_curPos.top, m_curPos.Width(), m_curPos.Height() * 6);

	switch(m_objIuff->GetTipo()) {
		case TP_IUFF:
			m_cboType.SelectString(-1, "iuff");
		break;

		case TP_TEXT:
			m_cboType.SelectString(-1, "text");
		break;

		case TP_FUNCION:
			m_cboType.SelectString(-1, "function");
		break;
		
		case TP_PARAM:
			m_cboType.SelectString(-1, "param");
		break;

		case TP_CODE:
			m_cboType.SelectString(-1, "code");
		break;

		default:
			m_cboType.SelectString(-1, "iuff");
		break;
	}
	if(m_objIuff->GetPersist()) {
		m_chkPersist.SetCheck(BST_CHECKED);
	}
	else {
		m_chkPersist.SetCheck(BST_UNCHECKED);
	}
	OnSelchangeCombo();
	
	CenterWindow();
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDlgWkiEventoMWIuff::SetIuff(CIuff* p_objIuff) {
	m_objIuff = p_objIuff;
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDlgWkiEventoMWIuff::OnCancel() {
	cdxCDynamicDialog::OnCancel();
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDlgWkiEventoMWIuff::OnOK() {
	CString strData;

	m_edtName.GetWindowText(strData);
	strData.TrimLeft(); strData.TrimRight();
	if(strData.GetLength() == 0) {
		AfxMessageBox("You must supply a valid name for this IUFF", MB_ICONERROR);
		return;
	}
	m_objIuff->SetNombre(strData);
	if(m_chkPersist.GetCheck() == BST_CHECKED) {
		m_objIuff->SetPersist(true);
	}
	else {
		m_objIuff->SetPersist(false);
	}
	m_cboType.GetLBText(m_cboType.GetCurSel(), strData);
	if(strData == "iuff") {
		m_objIuff->SetTipo(TP_IUFF);
		m_edtText.GetWindowText(strData);
		m_objIuff->SetLoadFrom(strData);
	}
	else if(strData == "text") {
		m_objIuff->SetTipo(TP_TEXT);
		m_edtText.GetWindowText(strData);
		m_objIuff->SetLoadFrom(strData);
	}
	else if(strData == "param") {
		m_objIuff->SetTipo(TP_PARAM);
		m_edtText.GetWindowText(strData);
		m_objIuff->SetLoadFrom(strData);
	}
	else if(strData == "code") {
		m_objIuff->SetTipo(TP_CODE);
		m_objIuff->SetLoadFrom(m_ctrlCode.GetText());
	}
	else if(strData == "function") {
		m_objIuff->SetTipo(TP_FUNCION);
		m_cboMetodo.GetLBText(m_cboMetodo.GetCurSel(), strData);
		m_objIuff->SetLoadFrom(strData);
	}
	cdxCDynamicDialog::OnOK();
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDlgWkiEventoMWIuff::OnSelchangeCombo() {
	CString strCurr;

	m_cboType.GetLBText(m_cboType.GetCurSel(), strCurr);
	m_edtText.ShowWindow(SW_HIDE);
	m_cboMetodo.ShowWindow(SW_HIDE);
	m_ctrlCode.ShowWindow(SW_HIDE);

	if(strCurr == "iuff") {
		m_edtText.ShowWindow(SW_SHOW);
		m_edtText.SetWindowText(m_objIuff->GetLoadFrom());
	}

	if(strCurr == "text") {
		m_edtText.ShowWindow(SW_SHOW);
		m_edtText.SetWindowText(m_objIuff->GetLoadFrom());
	}

	if(strCurr == "param") {
		m_edtText.ShowWindow(SW_SHOW);
		m_edtText.SetWindowText(m_objIuff->GetLoadFrom());
	}

	if(strCurr == "function") {
		m_cboMetodo.ShowWindow(SW_SHOW);
		m_cboMetodo.SelectString(-1, m_objIuff->GetLoadFrom());
	}

	if(strCurr == "code") {
		m_ctrlCode.ShowWindow(SW_SHOW);
		m_ctrlCode.SetText(m_objIuff->GetLoadFrom());
		m_ctrlCode.EmptyUndoBuffer();
	}
}