#include "stdafx.h"
#include "CompressorWrp.h"
#include "Globales.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
CCompressorWrp::CCompressorWrp() {
	m_objHelper = NULL;
	m_objHelperB64 = NULL;
	m_objZip = NULL;
	m_objUnzip = NULL;
}

CCompressorWrp::~CCompressorWrp() {
	RELEASE_NOT_NULL(m_objHelper);
	RELEASE_NOT_NULL(m_objHelperB64);
	RELEASE_NOT_NULL(m_objZip);
	RELEASE_NOT_NULL(m_objUnzip);
}

//////////////////////////////////////////////////////////////////////
// 
BOOL CCompressorWrp::Init() {
	if(FAILED(CoCreateInstance(__uuidof(TLCompressor::TLUnzip), NULL, CLSCTX_ALL, __uuidof(TLCompressor::ITLUnzip), reinterpret_cast<void**>(&m_objUnzip)))) {
		return FALSE;
	}
	if(FAILED(CoCreateInstance(__uuidof(TLCompressor::TLZip), NULL, CLSCTX_ALL, __uuidof(TLCompressor::ITLZip), reinterpret_cast<void**>(&m_objZip)))) {
		RELEASE_NOT_NULL(m_objUnzip);
		return FALSE;
	}
	if(FAILED(CoCreateInstance(__uuidof(TLCompressor::HelperBase64), NULL, CLSCTX_ALL, __uuidof(TLCompressor::IHelperBase64), reinterpret_cast<void**>(&m_objHelperB64)))) {
		RELEASE_NOT_NULL(m_objUnzip);
		RELEASE_NOT_NULL(m_objZip);
		return FALSE;
	}
	if(FAILED(CoCreateInstance(__uuidof(TLCompressor::Helper), NULL, CLSCTX_ALL, __uuidof(TLCompressor::IHelper), reinterpret_cast<void**>(&m_objHelper)))) {
		RELEASE_NOT_NULL(m_objHelperB64);
		RELEASE_NOT_NULL(m_objUnzip);
		RELEASE_NOT_NULL(m_objZip);
		return FALSE;
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
BOOL CCompressorWrp::Descomprimir(CString& strCode) {
	int iPos, iPos2;
	DWORD dwLargo;
	CString strType;

	if(!Init()) {
		return FALSE;
	}

	iPos = strCode.Find(_T("~"));
	if(iPos == -1) return FALSE;
	strType = strCode.Left(iPos);
	iPos2 = strCode.Find(_T("~"), iPos + 1);
	if(iPos2 == -1) return FALSE;
	dwLargo = _ttoi(strCode.Mid(iPos + 1, iPos2 - iPos));
	strCode = strCode.Mid(iPos2 + 1);

	BYTE* bufIn; BYTE* bufOut;
	
	DWORD dwLength = strCode.GetLength();
	long lLargo;
	bufIn = (BYTE*)malloc(dwLength);
	bufOut = (BYTE*)malloc(dwLargo + 1); ZeroMemory(bufOut, dwLargo + 1);
	memcpy(bufIn, (LPCTSTR)strCode, dwLength);
	if(strType == _T("B64")) {
		lLargo = m_objHelperB64->Decode((long)bufIn, dwLength);
	}
	else {
		m_objHelper->HexaToStream((long)bufIn, dwLength);
		lLargo = dwLength / 2;
	}
	long lenBuf = dwLargo;
	if(SUCCEEDED(m_objUnzip->ExtractStreamIntoStream((long)bufIn, lLargo, (long)bufOut, &lenBuf))) {
		strCode = bufOut;
		// Se copi, ahora lo puedo liberar
		free(bufIn);
		free(bufOut);
		return TRUE;
	}
	free(bufIn);
	free(bufOut);
	return FALSE;
}

//////////////////////////////////////////////////////////////////////
// 
BOOL CCompressorWrp::ComprimirB64(LPCTSTR p_strCode, CString& p_strRet) {
	if(!Init()) {
		return FALSE;
	}

	long lLength = lstrlen(p_strCode);
	long lCompressedLength;

	m_objZip->SetCompressionLevel(9);
	BYTE* bytBuffer = (BYTE*)malloc(m_objZip->SuggestBufferSize(lLength));
	m_objZip->CompressStreamToStream((long)p_strCode, lLength, (long)bytBuffer, &lCompressedLength);


	LPTSTR buffer = p_strRet.GetBuffer(m_objHelperB64->GetSuggestedBufferSize(lCompressedLength) + 1);
	long lLengthEncoded = m_objHelperB64->Encode((long)bytBuffer, lCompressedLength, (long)buffer);
	p_strRet.ReleaseBuffer();
	CString strIns;
	strIns.Format("B64~%i~", lLength);
	p_strRet.Insert(0, strIns);
	free(bytBuffer);
	return TRUE;
}