#include "stdafx.h"
#include "Globales.h"
#include "Configuracion.h"
#include <MyKey.h>
#include <PasswordMngr.h>

//////////////////////////////////////////////////////////////////////
// Constructor
CConfiguracion::CConfiguracion() {
	CMyKey objKey;
	CPasswordMngr objPass;
	
	objKey.OpenCreate(APP_NAME, _T("DB Configuration"), HKEY_CURRENT_USER);
	objKey.GetCreateValue(_T("Server"), m_strDBServer, _T("192.168.1.194"));
	objKey.GetCreateValue(_T("User"), m_strDBUser, _T("sa"));
	objKey.GetCreateValue(_T("Password"), m_strDBPass, _T(""));
	objKey.GetCreateValue(_T("Base"), m_strDBBase, _T("MMProDat"));
	objKey.Close();

	LPTSTR strOut;
	objPass.Desencriptar(m_strDBPass.c_str(), &strOut);
	m_strDBPass = strOut;
	free(strOut);

	objKey.OpenCreate(APP_NAME, _T("Application"));
	objKey.GetCreateValue(_T("Name"), m_strAppName, _T("CompInteract"));
	objKey.GetCreateValue(_T("Version"), m_strAppVer, _T("2.6.00"));
	objKey.Close();
}

//////////////////////////////////////////////////////////////////////
// Destructor
CConfiguracion::~CConfiguracion() {}

//////////////////////////////////////////////////////////////////////
// 
BOOL CConfiguracion::Initialize() {
	// Leer la info de la registry y meterla en las variables
	TCHAR buffer[MAX_PATH];
	GetCurrentDirectory(MAX_PATH, buffer);
	
	if(buffer[lstrlen(buffer) - 1] != '\\') {
		lstrcat(buffer, _T("\\"));
	}

	CEvaluadorLUA objEval;
	lua_State* L;

	CString strFile;
	strFile.Format("%ssettings.lua", buffer);

	if(objEval.RunFile(strFile) != 0) {
		return FALSE;
	}
	L = (lua_State*)objEval;
	lua_getglobal(L, "IuffFunctions");
	if(lua_type(L, -1) == LUA_TTABLE) {
		lua_pushnil(L);
		while(lua_next(L, -2) != 0) {
			LPCTSTR str = lua_tostring(L, -1);
			m_arrFuncs.Add(str);
			lua_pop(L,1);
		}
	}

	lua_getglobal(L, "Channels");
	if(lua_type(L, -1) == LUA_TTABLE) {
		lua_pushnil(L);
		while(lua_next(L, -2) != 0) {
			LPCTSTR str = lua_tostring(L, -1);
			m_arrChannels.Add(str);
			lua_pop(L,1);
		}
	}

	lua_getglobal(L, "ScintillaConfigFiles");
	if(lua_type(L, -1) == LUA_TTABLE) {
		lua_pushnil(L);
		while(lua_next(L, -2) != 0) {
			CString strCtrl = objEval.GetStringProp("Control");
			CString strFile = objEval.GetStringProp("File");
			strFile.Insert(0, buffer);
			m_mapaConfFiles.SetAt(strCtrl, strFile);
			lua_pop(L, 1);
		}
	}	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
LPCTSTR CConfiguracion::GetSQLConnectionString() {
	if(m_strSQLConn == _T("")) {
		if(m_strSQLConn == "") {
			m_strSQLConn = _T("Provider=SQLOLEDB.1;Persist Security Info=False;User ID=");
			m_strSQLConn += m_strDBUser;
			m_strSQLConn += _T(";Initial Catalog=");
			m_strSQLConn += m_strDBBase;
			m_strSQLConn += _T(";Data Source=");
			m_strSQLConn += m_strDBServer;
			m_strSQLConn += _T(";Password=");
			m_strSQLConn += m_strDBPass;
		}
	}
    return m_strSQLConn.c_str();
}

//////////////////////////////////////////////////////////////////////
// 
void CConfiguracion::GetIuffFunctions(CStringArray& p_arrFuncs) {
	p_arrFuncs.Copy(m_arrFuncs);
}

//////////////////////////////////////////////////////////////////////
// 
void CConfiguracion::GetBoundChannels(CStringArray& p_arrChannels) {
	p_arrChannels.Copy(m_arrChannels);
}

//////////////////////////////////////////////////////////////////////
// 
CString CConfiguracion::GetControlFile(LPCTSTR strCtrl) {
	CString strRet;
	if(m_mapaConfFiles.Lookup(strCtrl, strRet)) {
		return strRet;
	}
	return "";
}

//////////////////////////////////////////////////////////////////////
// 
BOOL CConfiguracion::Update() {
	CMyKey objKey;
	CPasswordMngr objPass;

	m_strSQLConn = _T("");

	LPTSTR strOut;
	objPass.Encriptar(m_strDBPass.c_str(), &strOut);

	objKey.Open(APP_NAME, _T("DB Configuration"), HKEY_CURRENT_USER);
	objKey.SetValue(_T("Server"), m_strDBServer.c_str());
	objKey.SetValue(_T("User"), m_strDBUser.c_str());
	objKey.SetValue(_T("Password"), strOut);
	objKey.SetValue(_T("Base"), m_strDBBase.c_str());
	objKey.Close();

	objKey.Open(APP_NAME, _T("Application"));
	objKey.SetValue(_T("Name"), m_strAppName.c_str());
	objKey.SetValue(_T("Version"), m_strAppVer.c_str());
	objKey.Close();
	free(strOut);
	return TRUE;
}