#include "stdafx.h"
#include "DefWorkitem.h"
#include "Metodo.h"
#include "EventosMW.h"
#include "Maquina.h"

//////////////////////////////////////////////////////////////////////
// Constructor
CDefWorkitem::CDefWorkitem() {
	m_objMaquina = NULL;
	m_strTipo = NULL;
	m_strDescripcion = NULL;
	m_strCanal = NULL;
}

//////////////////////////////////////////////////////////////////////
// Destructor
CDefWorkitem::~CDefWorkitem() {
	DELETE_NOT_NULL(m_objMaquina);
	m_mapaMetodos.Destroy();
	FREE_NOT_NULL(m_strTipo);
	FREE_NOT_NULL(m_strDescripcion);
	FREE_NOT_NULL(m_strCanal);
}

//////////////////////////////////////////////////////////////////////
// 
void CDefWorkitem::SetTipo(LPCTSTR strData) {
	CopiarString(m_strTipo, strData);
}
void CDefWorkitem::SetDescripcion(LPCTSTR strData) {
	CopiarString(m_strDescripcion, strData);
}
void CDefWorkitem::SetCanal(LPCTSTR strData) {
	CopiarString(m_strCanal, strData);
}
void CDefWorkitem::SetMaquina(CMaquina* p_objMaq) {
	DELETE_NOT_NULL(m_objMaquina);	// Borro la mquina vieja
	m_objMaquina = p_objMaq;
}

//////////////////////////////////////////////////////////////////////
// 
void CDefWorkitem::AddMetodo(CMetodo* p_objMetodo) {
	m_mapaMetodos.SetAt(p_objMetodo->GetNombre(), p_objMetodo);
}

//////////////////////////////////////////////////////////////////////
// 
void CDefWorkitem::RemoveMetodo(CMetodo* p_objMetodo) {
	m_mapaMetodos.Remove(p_objMetodo->GetNombre());
	delete p_objMetodo;
}

//////////////////////////////////////////////////////////////////////
// 
CMyMapIterador<CMetodo*>* CDefWorkitem::GetMetodos() {
	return new CMyMapIterador<CMetodo*>(&m_mapaMetodos);
}