#include "stdafx.h"
#include "Estado.h"
#include "TimedAction.h"
#include "Transicion.h"

////////////////////////////////////////////////////////////////////
// Constructor
CEstado::CEstado() {
	m_bInitial = FALSE;
	m_strID = NULL;
	m_strDesc = NULL;
	m_strOnEntry = NULL;
	m_strOnExit = NULL;
}

//////////////////////////////////////////////////////////////////////
// Destructor
CEstado::~CEstado() {
	m_mapaTimedActions.Destroy();
	for(int i = 0; i < m_arrTransiciones.GetSize(); i++) {
		delete m_arrTransiciones.GetAt(i);
	}
	FREE_NOT_NULL(m_strID);
	FREE_NOT_NULL(m_strDesc);
	FREE_NOT_NULL(m_strOnEntry);
	FREE_NOT_NULL(m_strOnExit);
}

//////////////////////////////////////////////////////////////////////
// 
void CEstado::SetRect(CRect& rc) {
	m_rcPos = rc;
}

//////////////////////////////////////////////////////////////////////
// 
void CEstado::SetOnEntryFromXml(LPCTSTR strData) {
	CopiarString(m_strOnEntry, strData);
}
void CEstado::SetOnEntry(LPCTSTR strData) {
	CopiarString(m_strOnEntry, strData);
}

//////////////////////////////////////////////////////////////////////
// 
void CEstado::SetOnExitFromXml(LPCTSTR strData) {
	CopiarString(m_strOnExit, strData);
}
void CEstado::SetOnExit(LPCTSTR strData) {
	CopiarString(m_strOnExit, strData);
}

//////////////////////////////////////////////////////////////////////
// 
void CEstado::AddTimedAction(CTimedAction* p_objTA) {
	m_mapaTimedActions.SetAt(p_objTA->GetTime(), p_objTA);
}

//////////////////////////////////////////////////////////////////////
// 
void CEstado::RemoveTimedAction(CTimedAction* p_objTA) {
	m_mapaTimedActions.Remove(p_objTA->GetTime());
	delete p_objTA;
}

//////////////////////////////////////////////////////////////////////
// 
void CEstado::AddTransicion(CTransicion* objTran) {
	m_arrTransiciones.Add(objTran);
}

//////////////////////////////////////////////////////////////////////
// 
void CEstado::RemoveTransicion(CTransicion* p_objTran) {
	for(int i = 0; i < m_arrTransiciones.GetSize(); i++) {
		CTransicion* oTran = m_arrTransiciones.GetAt(i);
		if(oTran == p_objTran) {
			m_arrTransiciones.RemoveAt(i);
			return;
		}
	}
}

//////////////////////////////////////////////////////////////////////
// 
void CEstado::RemoveTransicion(int p_iIndex) {
	m_arrTransiciones.RemoveAt(p_iIndex);
}

//////////////////////////////////////////////////////////////////////
// 
CMyMapIterador<CTimedAction*>* CEstado::GetTimedActions() {
	return new CMyMapIterador<CTimedAction*>(&m_mapaTimedActions);
}

//////////////////////////////////////////////////////////////////////
// 
const CArray<CTransicion*,CTransicion*>* CEstado::GetTransiciones() const {
	return &m_arrTransiciones;
}