#if !defined(AFX_ESTADO_H__20CB076C_461E_4A94_AFCD_3ACCED14A944__INCLUDED_)
#define AFX_ESTADO_H__20CB076C_461E_4A94_AFCD_3ACCED14A944__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyMap.h"
class CTimedAction;
class CTransicion;

#include "Globales.h"

class CEstado {
public:
	CEstado();
	virtual ~CEstado();

public:
	void SetID(LPCTSTR strData) { CopiarString(m_strID, strData); };
	void SetDescripcion(LPCTSTR strData) { CopiarString(m_strDesc, strData); };
	void SetInitial(BOOL bData) { m_bInitial = bData; };

	void SetOnEntryFromXml(LPCTSTR strData);
	void SetOnEntry(LPCTSTR strData);
	void SetOnExitFromXml(LPCTSTR strData);
	void SetOnExit(LPCTSTR strData);

	void SetRect(CRect& rc);
	const CRect& GetRect() const { return m_rcPos; };

	void AddTimedAction(CTimedAction* objTA);
	void RemoveTimedAction(CTimedAction* objTA);

	void AddTransicion(CTransicion* objTran);
	void RemoveTransicion(CTransicion* objTran);
	void RemoveTransicion(int iIndex);


	LPCTSTR GetID() { return m_strID; };
	LPCTSTR GetDescripcion() { return m_strDesc; };
	BOOL IsInitial() { return m_bInitial; };
	LPCTSTR GetOnEntry() { return m_strOnEntry; };
	LPCTSTR GetOnExit() { return m_strOnExit; };
	BOOL HayOnEntry() { return lstrlen(m_strOnEntry); };
	BOOL HayOnExit() { return lstrlen(m_strOnExit); };
	CMyMapIterador<CTimedAction*>* GetTimedActions();
	const CArray<CTransicion*,CTransicion*>* GetTransiciones() const;


private:
	char* m_strID;
	char* m_strDesc;
	char* m_strOnEntry;
	char* m_strOnExit;
	CRect m_rcPos;
	BOOL m_bInitial;
	CMyMap<CTimedAction*> m_mapaTimedActions;
	CArray<CTransicion*,CTransicion*> m_arrTransiciones;
};

#endif // !defined(AFX_ESTADO_H__20CB076C_461E_4A94_AFCD_3ACCED14A944__INCLUDED_)
