#include "stdafx.h"
#include "..\compintdesigner.h"
#include "FlowToMaquina.h"

#include "..\AddFlow\Link.h"
#include "..\AddFlow\Links.h"
#include "..\AddFlow\LinkPoints.h"
#include "..\AddFlow\LinkPoint.h"
#include "..\AddFlow\Node.h"
#include "..\AddFlow\Nodes.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFlowToMaquina::CFlowToMaquina(CAddFlow* p_objAddFlow) : m_AddFlow(p_objAddFlow) {}

CFlowToMaquina::~CFlowToMaquina() {}

//////////////////////////////////////////////////////////////////////
// Actualiza una mquina con la informacin del dibujo
bool CFlowToMaquina::Update(CMaquina* p_objMaquina) {
	CNodes afNodes = m_AddFlow->GetNodes();
	CNode afNode;
	CLinks afLinks;
	CLink afLink;
	_variant_t var;
	CRect rect;
	CEstado* objEst;
	CTransicion* objTran;
	float x1, y1, x2, y2;
	CLinkPoints afLinkPoints;
	CLinkPoint afLinkPoint;
	CPoint pt;

	for(int i = 1; i <= afNodes.GetCount(); i++) {
		var = (short)i;
		afNode = afNodes.Item(var);
		objEst = (CEstado*)afNode.GetUserData();
		x1 = afNode.GetLeft();
		y1 = afNode.GetTop();
		x2 = x1 + afNode.GetWidth();
		y2 = y1 + afNode.GetHeight();
		rect.SetRect(x1, y1, x2, y2);
		objEst->SetRect(rect);

		afLinks = afNode.GetOutLinks();
		for(int j = 1; j <= afLinks.GetCount(); j++) {
			var = (short)j;
			afLink = afLinks.Item(var);
			objTran = (CTransicion*)afLink.GetUserData();
			afLinkPoints = afLink.GetExtraPoints();
			objTran->ClearExtraPoints();
			long lCount = afLinkPoints.GetCount();
			for(long k = 1; k <= afLinkPoints.GetCount() - 2; k++) {
				afLinkPoint = afLinkPoints.GetItem(k);
				pt.x = afLinkPoint.GetX(); pt.y = afLinkPoint.GetY();
				objTran->AddExtraPoint(pt);
			}
		}
	}
	return true;
}