#include "stdafx.h"
#include "Iuff.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
CIuff::CIuff() {
	m_strNombre = NULL;
	m_strLoadFrom = NULL;
}

CIuff::~CIuff() {
	FREE_NOT_NULL(m_strNombre);
	FREE_NOT_NULL(m_strLoadFrom);
}

void CIuff::SetNombre(LPCTSTR strData) {
	CopiarString(m_strNombre, strData);
}
void CIuff::SetLoadFrom(LPCTSTR strData) {
	CopiarString(m_strLoadFrom, strData);
}
void CIuff::SetPersist(BOOL bData) {
	m_bPersist = bData;
}
void CIuff::SetTipo(LPCTSTR strData) {
	if(lstrcmpi(strData, _T("IUFF")) == 0) {
		m_tipo = TP_IUFF;
		return;
	}
	if(lstrcmpi(strData, _T("TEXT")) == 0) {
		m_tipo = TP_TEXT;
		return;
	}
	if(lstrcmpi(strData, _T("PARAM")) == 0) {
		m_tipo = TP_PARAM;
		return;
	}
	if(lstrcmpi(strData, _T("FUNCTION")) == 0) {
		m_tipo = TP_FUNCION;
		return;
	}
	if(lstrcmpi(strData, _T("CODE")) == 0) {
		m_tipo = TP_CODE;
		return;
	}
	m_tipo = TP_UNDEFINED;
}
void CIuff::SetTipo(TipoIUFF p_tipo) {
	m_tipo = p_tipo;
}

void CIuff::SetPersist(LPCTSTR strData) {
	if(lstrcmpi(strData, _T("T")) == 0 || lstrcmpi(strData, _T("TRUE")) == 0) {
		m_bPersist = TRUE;
	}
	else {
		m_bPersist = FALSE;
	}
}

LPCTSTR CIuff::GetNombre() {
	return m_strNombre;
}
LPCTSTR CIuff::GetLoadFrom() {
	return m_strLoadFrom;
}
BOOL CIuff::GetPersist() {
	return m_bPersist;
}
LPCTSTR CIuff::GetPersistStr() {
	return (m_bPersist) ? _T("T") : _T("F");
}

LPCTSTR CIuff::GetTipoStr() {
	switch(m_tipo) {
	case TP_IUFF:
		return _T("IUFF");
	case TP_TEXT:
		return _T("TEXT");
	case TP_PARAM:
		return _T("PARAM");
	case TP_FUNCION:
		return _T("FUNCTION");
	case TP_CODE:
		return _T("CODE");
	}
	return _T("");
}