#include "stdafx.h"
#include "Maquina.h"
#include "Estado.h"
#include "Transicion.h"

//////////////////////////////////////////////////////////////////////
// Constructor
CMaquina::CMaquina() {}

//////////////////////////////////////////////////////////////////////
// Destructor
CMaquina::~CMaquina() {
	m_mapaEstados.Destroy();
}

//////////////////////////////////////////////////////////////////////
// 
void CMaquina::AddEstado(CEstado* objEst) {
	m_mapaEstados.SetAt(objEst->GetID(), objEst);
}

//////////////////////////////////////////////////////////////////////
// 
void CMaquina::RemoveEstado(CEstado* p_objEst) {
	m_mapaEstados.Remove(p_objEst->GetID());
	
	// Esto es un asco, cambiarlo por algo ms rpido
	const CArray<CTransicion*,CTransicion*>* arrTrans;
	for(int i = 0; i < m_mapaEstados.GetCount(); i++) {
		CEstado* objEst;
		m_mapaEstados.GetItemAt(i, &objEst);
		arrTrans = objEst->GetTransiciones();
		for(int j = 0; j < arrTrans->GetSize(); j++) {
			 CTransicion* objTran = arrTrans->GetAt(j);
			 if(objTran->GetDestino() == p_objEst) {
				 // Encontr una transicin que llega al estado que estoy borrando
				 objEst->RemoveTransicion(j);
				 delete objTran;
				 j--;
			 }
		 }
	}
	delete p_objEst;
}

//////////////////////////////////////////////////////////////////////
// 
CEstado* CMaquina::GetEstado(LPCTSTR strID) {
	CEstado* objEst;
	m_mapaEstados.Lookup(strID, &objEst);
	return objEst;
}

//////////////////////////////////////////////////////////////////////
// 
CMyMapIterador<CEstado*>* CMaquina::GetEstados() {
	return new CMyMapIterador<CEstado*>(&m_mapaEstados);
}

//////////////////////////////////////////////////////////////////////
// Setea el estado inicial. Si ya hay uno inicial, retorna el viejo (NULL en caso contrario)
CEstado* CMaquina::SetEstadoInicial(CEstado* p_objEst) {
	for(int i = 0; i < m_mapaEstados.GetCount(); i++) {
		CEstado* objEst;
		m_mapaEstados.GetItemAt(i, &objEst);
		if(objEst->IsInitial()) {
			// Si es inicial
			if(objEst != p_objEst) {
				// Pero no es el nuevo, lo cambio
				objEst->SetInitial(FALSE);
				return objEst;
			}
		}
	}
	return NULL;
}