#include "stdafx.h"
#include "Transicion.h"

//////////////////////////////////////////////////////////////////////
// Constructor
CTransicion::CTransicion() {
	m_strNombre = NULL;
	m_strAccion = NULL;
	m_strTipoAccion = NULL;
	m_strCondicion = NULL;
	m_strDescripcion = NULL;
}

//////////////////////////////////////////////////////////////////////
// Destructor
CTransicion::~CTransicion() {
	FREE_NOT_NULL(m_strNombre);
	FREE_NOT_NULL(m_strAccion);
	FREE_NOT_NULL(m_strTipoAccion);
	FREE_NOT_NULL(m_strCondicion);
	FREE_NOT_NULL(m_strDescripcion);
}

//////////////////////////////////////////////////////////////////////
// 
void CTransicion::ClearExtraPoints() {
	m_lstPuntos.RemoveAll();
}

//////////////////////////////////////////////////////////////////////
// 
void CTransicion::AddExtraPoint(CPoint& pt) {
	m_lstPuntos.Add(pt);
}

//////////////////////////////////////////////////////////////////////
// 
const CArray<CPoint,CPoint>* CTransicion::GetExtraPoints() const {
	return &m_lstPuntos;
}

//////////////////////////////////////////////////////////////////////
// 
BOOL CTransicion::HayAccion() {
	if(lstrcmpi(m_strTipoAccion, _T("default")) == 0) {
		return TRUE;
	}
	if((lstrcmpi(m_strTipoAccion, _T("custom")) == 0) && lstrlen(m_strAccion)) {
		return TRUE;
	}
	return FALSE;
}

//////////////////////////////////////////////////////////////////////
// 
void CTransicion::SetTipoAccion(TipoAccion tpAct) {
	switch(tpAct) {
		case SIN_ACCION:
			CopiarString(m_strTipoAccion, "");
			CopiarString(m_strAccion, "");
		break;

		case DEFAULT:
			CopiarString(m_strTipoAccion, "default");
			CopiarString(m_strAccion, "");
		break;

		case CUSTOM:
			CopiarString(m_strTipoAccion, "custom");
		break;
	}
}

//////////////////////////////////////////////////////////////////////
// 
TipoAccion CTransicion::GetTipoAccion() {
	if(lstrcmpi(m_strTipoAccion, _T("default")) == 0) {
		return DEFAULT;
	}
	if((lstrcmpi(m_strTipoAccion, _T("custom")) == 0) && lstrlen(m_strAccion)) {
		return CUSTOM;
	}
	return SIN_ACCION;
}