#if !defined(AFX_TRANSICION_H__5EF616D0_6A7F_4ED9_93F7_635EC1BBE33F__INCLUDED_)
#define AFX_TRANSICION_H__5EF616D0_6A7F_4ED9_93F7_635EC1BBE33F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Estado.h"

typedef enum {
	SIN_ACCION = 0,
	DEFAULT = 1,
	CUSTOM = 2
} TipoAccion;

class CTransicion {
public:
	CTransicion();
	virtual ~CTransicion();

public:
	void SetOrigen(CEstado* obj) { m_estOrigen = obj; };
	void SetDestino(CEstado* obj) { m_estDestino = obj; };
	void SetNombre(LPCTSTR strData) { CopiarString(m_strNombre, strData); };
	void SetAccion(LPCTSTR strData) { CopiarString(m_strAccion, strData); };
	void SetCondicion(LPCTSTR strData) { CopiarString(m_strCondicion, strData); };
	void SetTipoAccion(LPCTSTR strData) { CopiarString(m_strTipoAccion, strData); };
	void SetTipoAccion(TipoAccion tpAct);
	TipoAccion GetTipoAccion();

	void SetDescripcion(LPCTSTR strData) { CopiarString(m_strDescripcion, strData); };
	LPCTSTR GetDescripcion() { return m_strDescripcion; };

	void ClearExtraPoints();
	void AddExtraPoint(CPoint& pt);
	const CArray<CPoint,CPoint>* GetExtraPoints() const;

	CEstado* GetOrigen() const { return m_estOrigen; };
	CEstado* GetDestino() const { return m_estDestino; };
	LPCTSTR GetNombre() { return m_strNombre; };
	BOOL HayCondicion() { return lstrlen(m_strCondicion); };
	BOOL HayAccion();
	LPCTSTR GetTipoAccionStr() { return m_strTipoAccion; };
	LPCTSTR GetAccion() { return m_strAccion; };
	LPCTSTR GetCondicion() { return m_strCondicion; };
	
private:
	CEstado* m_estOrigen;
	CEstado* m_estDestino;
	char* m_strNombre;
	char* m_strAccion;
	char* m_strTipoAccion;
	char* m_strCondicion;
	char* m_strDescripcion;
	CArray<CPoint,CPoint> m_lstPuntos;
};

#endif // !defined(AFX_TRANSICION_H__5EF616D0_6A7F_4ED9_93F7_635EC1BBE33F__INCLUDED_)
