#include "stdafx.h"
#include "blogger.h"
#include "..\..\includes\libBlogger\libblogger.h"

static bool bFirstRun = true;
static CLog* objLog = NULL;

//////////////////////////////////////////////////////////////////////////
/// 
static void Initialize() {
	objLog = CreateLog2(_T("CompIntDesigner"));
}

//////////////////////////////////////////////////////////////////////////
///
void LogFree() {
	if(objLog) {
		DeleteLog(objLog);
		objLog = NULL;
	}
}

//////////////////////////////////////////////////////////////////////////
///
void LogDebug(LPCTSTR strFormat, ...) {
	if(bFirstRun) {
		Initialize();
		bFirstRun = false;
	}
	va_list argptr;
	va_start(argptr, strFormat);
	objLog->Debug(strFormat, argptr);
	va_end(argptr);
}

//////////////////////////////////////////////////////////////////////////
///
void LogInfo(LPCTSTR strFormat, ...) {
	if(bFirstRun) {
		Initialize();
		bFirstRun = false;
	}
	va_list argptr;
	va_start(argptr, strFormat);
	objLog->Info(strFormat, argptr);
	va_end(argptr);
}

//////////////////////////////////////////////////////////////////////////
///
void LogWarning(LPCTSTR strFormat, ...) {
	if(bFirstRun) {
		Initialize();
		bFirstRun = false;
	}
	va_list argptr;
	va_start(argptr, strFormat);
	objLog->Warning(strFormat, argptr);
	va_end(argptr);
}

//////////////////////////////////////////////////////////////////////////
///
void LogError(LPCTSTR strFormat, ...) {
	if(bFirstRun) {
		Initialize();
		bFirstRun = false;
	}
	va_list argptr;
	va_start(argptr, strFormat);
	objLog->Error(strFormat, argptr);
	va_end(argptr);
}

//////////////////////////////////////////////////////////////////////////
///
void LogFatal(LPCTSTR strFormat, ...) {
	if(bFirstRun) {
		Initialize();
		bFirstRun = false;
	}
	va_list argptr;
	va_start(argptr, strFormat);
	objLog->Fatal(strFormat, argptr);
	va_end(argptr);
}
