#include "stdafx.h"
#include "Drawer.h"
#include "Addflow\AddflowConst.h"
#include "AddFlow\Node.h"
#include "AddFlow\Nodes.h"
#include "AddFlow\Link.h"
#include "AddFlow\Links.h"
#include "AddFlow\LinkPoint.h"
#include "AddFlow\LinkPoints.h"
#include "Domain\Estado.h"
#include "Domain\Transicion.h"
#include "resource.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
CDrawer::CDrawer(CAddFlow* p_objAddFlow) : m_AddFlow(p_objAddFlow) {
	m_picEstado.CreateFromIcon(IDI_ICON_ESTADO);
}

CDrawer::~CDrawer() {}

//////////////////////////////////////////////////////////////////////
// 
bool CDrawer::Draw(CMaquina* p_objMaquina) {
	CMyMapIterador<CEstado*>* iterador = p_objMaquina->GetEstados();
	if(iterador->begin()) {
		while(*iterador) {
			DrawEstado((*iterador)++);		
		}
	}

	if(iterador->begin()) {
		while(*iterador) {
			DrawLinks((*iterador)++);
			/*CEstado* objEst = ;
			const CArray<CTransicion*, CTransicion*>* arrTran;
			arrTran = objEst->GetTransiciones();
			for(int i = 0; i < arrTran->GetSize(); i++) {
				CTransicion* objTran = arrTran->GetAt(i);
				CEstado* objDest = objTran->GetDestino();
				CNode nodeOrig, nodeDest;
				_variant_t var;
				var = objEst->GetID();
				nodeOrig = m_AddFlow.GetNodes().Item(var);
				var = objDest->GetID();
				nodeDest = m_AddFlow.GetNodes().Item(var);
				AddLink(&nodeOrig, &nodeDest);
			}*/
		}
	}
	delete iterador;
	return true;
}

//////////////////////////////////////////////////////////////////////
// 
CNode CDrawer::AddEstado(CEstado* p_objEst) {
	CNode afNode;

#pragma warning( disable : 4244 )
	afNode = m_AddFlow->GetNodes().Add(0,0,1155,705);
#pragma warning( default : 4244 )
	afNode.SetUserData((long)p_objEst);
	afNode.SetHidden(FALSE);
	afNode.SetShape(afProcess);
	afNode.SetKey(p_objEst->GetID());
	afNode.SetText(p_objEst->GetDescripcion());
	afNode.SetAlignment(afCenterBOTTOM);
	if(p_objEst->IsInitial()) {
		afNode.SetDrawColor(RGB(0,0,255));
		afNode.SetDrawStyle(afSolid);
	}
	else {
		afNode.SetDrawStyle(afTransparent);
	}
	afNode.SetPicture(m_picEstado.GetPictureDispatch());
	//afNode.SetPicturePosition(afRelativeToText);
	afNode.SetPicturePosition(afPictureCenterTOP);
	afNode.SetTransparent(TRUE);
	//afNode.SetAutoSize(afAdjustNodeSizetoPicture);
	return afNode;
}

//////////////////////////////////////////////////////////////////////
// 
void CDrawer::UpdateEstado(CNode* p_afNode, CEstado* p_objEst) {
	p_afNode->SetUserData((long)p_objEst);
	p_afNode->SetHidden(FALSE);
	p_afNode->SetShape(afProcess);
	p_afNode->SetKey(p_objEst->GetID());
	p_afNode->SetText(p_objEst->GetDescripcion());
	if(p_objEst->IsInitial()) {
		p_afNode->SetDrawColor(RGB(0,0,255));
		p_afNode->SetDrawStyle(afSolid);
	}
	else {
		p_afNode->SetDrawStyle(afTransparent);
		p_afNode->SetDrawColor(RGB(0,0,0));
	}
	p_afNode->SetPicture(m_picEstado.GetPictureDispatch());
	//p_afNode->SetPicturePosition(afRelativeToText);
	p_afNode->SetPicturePosition(afPictureCenterTOP);
	p_afNode->SetTransparent(TRUE);
}

/*//////////////////////////////////////////////////////////////////////
// 
CLink CDrawer::AddTransicion(CTransicion* objTran) {
	
}*/

//////////////////////////////////////////////////////////////////////
// 
void CDrawer::UpdateTransicion(CLink* p_afLink, CTransicion* p_objTran) {
	p_afLink->SetUserData((long)p_objTran);
	p_afLink->SetText(p_objTran->GetNombre());
	p_afLink->SetDrawColor(RGB(255,0,0));
	if(lstrcmpi(p_objTran->GetNombre(), "noevent") == 0) {
		p_afLink->SetDrawColor(RGB(0,0,255));
	}
	else {
		p_afLink->SetDrawColor(RGB(255,0,0));
	}
}

//////////////////////////////////////////////////////////////////////
// 
void CDrawer::DrawEstado(CEstado* p_objEst) {
	CNode afNode;

	CRect rect = p_objEst->GetRect();
#pragma warning( disable : 4244 )
	afNode = m_AddFlow->GetNodes().Add(rect.left, rect.top, rect.Width(), rect.Height());
#pragma warning( default : 4244 )
	afNode.SetUserData((long)p_objEst);
	afNode.SetHidden(FALSE);
	afNode.SetShape(afProcess);
	afNode.SetKey(p_objEst->GetID());
	afNode.SetText(p_objEst->GetDescripcion());
	if(p_objEst->IsInitial()) {
		afNode.SetDrawColor(RGB(0,0,255));
		afNode.SetDrawStyle(afSolid);
	}
	else {
		afNode.SetDrawStyle(afTransparent);
	}
	afNode.SetPicture(m_picEstado.GetPictureDispatch());
	//afNode.SetPicturePosition(afRelativeToText);
	afNode.SetPicturePosition(afPictureCenterTOP);
	afNode.SetAlignment(afCenterBOTTOM);
	afNode.SetTransparent(TRUE);
	//afNode.SetAutoSize(afAdjustNodeSizetoPicture);
}

//////////////////////////////////////////////////////////////////////
// 
void CDrawer::DrawLinks(CEstado* p_objEst) {
	CNode afNodOrg, afNodDst;
	CTransicion* objTran;
	CLink afLink;
	_variant_t var;

	var = p_objEst->GetID();
	afNodOrg = m_AddFlow->GetNodes().Item(var);
	for(int i = 0; i < p_objEst->GetTransiciones()->GetSize(); i++) {
		objTran = p_objEst->GetTransiciones()->GetAt(i);
		var = objTran->GetDestino()->GetID();
		afNodDst = m_AddFlow->GetNodes().Item(var);
		afLink = afNodOrg.GetOutLinks().Add(afNodDst);
		afLink.SetUserData((long)objTran);
		afLink.SetText(objTran->GetNombre());
		if(lstrcmpi(objTran->GetNombre(), "noevent") == 0) {
			afLink.SetDrawColor(RGB(0,0,255));
		}
		else {
			afLink.SetDrawColor(RGB(255,0,0));
		}
		DrawExtraPoints(objTran->GetExtraPoints(), afLink);
	}
}

//////////////////////////////////////////////////////////////////////
// 
void CDrawer::DrawExtraPoints(const CArray<CPoint,CPoint>* p_arrPoints, CLink& p_afLink) {
	int iStoredPoints;
	if(p_arrPoints->GetSize() == 0) return;
	iStoredPoints = p_arrPoints->GetSize();
	
	int iAdd, iStart, iEnd, iPoints, i;
	//CArray<CPoint,CPoint> ptArray;
	CLinkPoints& extraPoints = p_afLink.GetExtraPoints();

	if(p_afLink.GetAdjustOrg() && p_afLink.GetAdjustDst()) {
		iAdd = iStoredPoints - 2;
		iPoints = iStoredPoints;
		/*ptArray.SetSize(iPoints);
		for(i = 0; i < p_arrPoints->GetSize(); i++) {
			ptArray.Add(p_arrPoints->GetAt(i));
		}*/
	}
	else {
		if(p_afLink.GetAdjustOrg()) {
			iAdd = iStoredPoints - 1;
			iPoints = iStoredPoints + 1;
			/*ptArray.SetSize(iPoints);
			for(i = 0; i < p_arrPoints->GetSize(); i++) {
				ptArray.SetAt(i + 1, p_arrPoints->GetAt(i));
			}*/
		}
		else {
			if(p_afLink.GetAdjustDst()) {
				iAdd = iStoredPoints - 1;
				iPoints = iStoredPoints + 1;
				/*ptArray.SetSize(iPoints);
				for(i = 0; i < p_arrPoints->GetSize(); i++) {
					ptArray.SetAt(i + 1, p_arrPoints->GetAt(i));
				}*/
			}
			else {
				iAdd = iStoredPoints;
				iPoints = iStoredPoints + 2;
				/*ptArray.SetSize(iPoints);
				for(i = 0; i < p_arrPoints->GetSize(); i++) {
					ptArray.SetAt(i + 1, p_arrPoints->GetAt(i));
				}*/
			}
		}
	}

	// Create the needed points
	if(p_afLink.GetLinkStyle() == afBezier || p_afLink.GetLinkStyle() == afPolyline) {
		// If reflexive link, then it has been created with 4 points instead 2
		// therefore there are 2 points we don't need to create.
		if(p_afLink.GetOrg().GetIndex() == p_afLink.GetDst().GetIndex()) {
			iAdd = iAdd - 2;
		}
		for(i = 0; i < iAdd; i++) {
			p_afLink.GetExtraPoints().Add(0,0);
		}
	}
	
	// Update points positions
	if(p_afLink.GetAdjustOrg()) {
		iStart = 0;
	}
	else {
		iStart = 1;
	}
	if(p_afLink.GetAdjustDst()) {
		iEnd = iPoints;
	}
	else {
		iEnd = iPoints - 1;
	}

	CLinkPoint pt;
	for(i = iStart; i < iEnd; i++) {
		pt = extraPoints.GetItem(i);
		//p = ptArray.GetAt(i);
		CPoint& p = p_arrPoints->GetAt(i - iStart);
		pt.SetX(p.x);
		pt.SetY(p.y);
		extraPoints.SetRefItem(i, pt);
	}
}