#include "stdafx.h"
#include "compintdesigner.h"
#include "EvalScintilla.h"
#include "scintilla.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEvalScintilla::CEvalScintilla(CScintilla* p_objCtrl) : m_objCtrl(p_objCtrl) {
	/*REG_LUAFUNC(CEvalScintilla, SetStyle, "SetStyle");

	// Esto debo hacerlo siempre que herede, sino cuando me va a llamar un mtodo
	// sobre un puntero a la clase base (plaf!)
	lua_pushnumber(L, (long)this);
	lua_setglobal(L, _T("lua_object"));*/
	Register(this);
}

CEvalScintilla::~CEvalScintilla() {};

//////////////////////////////////////////////////////////////////////
// 
COLORREF CEvalScintilla::GetRGB() {
	int r, g, b;

	if(!lua_istable(m_L, -1)) {
		// Valor por defecto
		lua_pop(m_L, 1);	// Saco la tabla
		return RGB(255,255,255);
	}
	lua_pushnumber(m_L, 1);
	lua_gettable(m_L, -2);
	r = lua_tonumber(m_L, -1);
	lua_pop(m_L, 1);
	lua_pushnumber(m_L, 2);
	lua_gettable(m_L, -2);
	g = lua_tonumber(m_L, -1);
	lua_pop(m_L, 1);
	lua_pushnumber(m_L, 3);
	lua_gettable(m_L, -2);
	b = lua_tonumber(m_L, -1);
	lua_pop(m_L, 2);	// Saco el ultimo valor y la tabla
	return RGB(r,g,b);
}

//////////////////////////////////////////////////////////////////////
// 
FONTDESC CEvalScintilla::GetFont() {
	CString strFontFace;
	FONTDESC font_desc;
	double dSize;
	BOOL bBold, bItalic, bUnderline;

	bBold = bItalic = bUnderline = FALSE;

	USES_CONVERSION;

	font_desc.cbSizeofstruct = sizeof(FONTDESC);

	if(!lua_istable(m_L, -1)) {
		// Valores por defecto
		lua_pop(m_L, 1);	// Saco la tabla
		font_desc.cbSizeofstruct = sizeof(FONTDESC);
		font_desc.cySize.int64 = 10 * 10000;
		font_desc.fItalic = bItalic;
		font_desc.fStrikethrough = FALSE;
		font_desc.fUnderline = bUnderline;
		font_desc.lpstrName = (unsigned short*)malloc(20);
		memcpy(font_desc.lpstrName, OLESTR("verdana"), 20);
		font_desc.sCharset = 0;
		font_desc.sWeight = FW_NORMAL;
		return font_desc;
	}
	lua_pushstring(m_L, "face");
	lua_gettable(m_L, -2);
	if(!lua_isnil(m_L, -1)) {
		strFontFace = lua_tostring(m_L, -1);
	}
	else {
		// valor por defecto
	}
	lua_pop(m_L, 1);

	lua_pushstring(m_L, "size");
	lua_gettable(m_L, -2);
	if(!lua_isnil(m_L, -1)) {
		dSize = lua_tonumber(m_L, -1);
	}
	else {
		// valor por defecto
	}
	lua_pop(m_L, 1);

	lua_pushstring(m_L, "bold");
	lua_gettable(m_L, -2);
	if(!lua_isnil(m_L, -1)) {
		bBold = lua_tonumber(m_L, -1);
	}
	lua_pop(m_L, 1);

	lua_pushstring(m_L, "italic");
	lua_gettable(m_L, -2);
	if(!lua_isnil(m_L, -1)) {
		bItalic = lua_tonumber(m_L, -1);
	}
	lua_pop(m_L, 1);

	lua_pushstring(m_L, "underline");
	lua_gettable(m_L, -2);
	if(!lua_isnil(m_L, -1)) {
		bUnderline = lua_tonumber(m_L, -1);
	}
	lua_pop(m_L, 1);

	// Saco la tabla
	lua_pop(m_L, 1);

	font_desc.cbSizeofstruct = sizeof(FONTDESC);
	font_desc.cySize.int64 = dSize * 10000;
	font_desc.fItalic = bItalic;
	font_desc.fStrikethrough = FALSE;
	font_desc.fUnderline = bUnderline;
	font_desc.lpstrName = (unsigned short*)malloc((strFontFace.GetLength() + 1) * 2);
	memcpy(font_desc.lpstrName, A2W(strFontFace), (strFontFace.GetLength() + 1) * 2);
	font_desc.sCharset = 0;
	if(bBold) {
		font_desc.sWeight = FW_BOLD;
	}
	else {
		font_desc.sWeight = FW_NORMAL;
	}
	return font_desc;
}

//////////////////////////////////////////////////////////////////////
// 
EVAL_FUNCIMP(CEvalScintilla, SetStyle) {
	COLORREF foreColor, backColor;

	if(!lua_istable(m_L, -1)) {
		lua_settop(m_L, 0);
		return 0;
	}
	int iStyle = lua_tonumber(m_L, -2);
	lua_pushstring(m_L, "fore");
	lua_gettable(m_L, -2);
	
	foreColor = GetRGB();
	lua_pushstring(m_L, "back");
	lua_gettable(m_L, -2);
	backColor = GetRGB();

	lua_pushstring(m_L, "font");
	lua_gettable(m_L, -2);	

	CFontHolder font(NULL);
	FONTDESC font_desc = GetFont();
	font.InitializeFont(&font_desc);

	lua_pushstring(m_L, "eolFilled");
	lua_gettable(m_L, -2);
	BOOL bEolFilled = lua_tonumber(m_L, -1);
	lua_pop(m_L, 1);

	m_objCtrl->SetStyle(iStyle, foreColor, backColor, font.GetFontDispatch(), TRUE, TRUE, 0, 0);
	lua_settop(m_L, 0);
	free(font_desc.lpstrName);
	return 0;
}

//////////////////////////////////////////////////////////////////////
/// Recupera la configuracin desde el script
BOOL CEvalScintilla::ObtenerConfig() {
	lua_getglobal(m_L, "editor");

	m_objCtrl->SetLanguage(GetStringProp("Language", "lua"));
	m_objCtrl->SetLexer(GetLongProp("Lexer", 15));
	m_objCtrl->SetMatchBraces(GetLongProp("MatchBraces"));
	m_objCtrl->SetHScrollBar(GetLongProp("HScrollBar"));
	m_objCtrl->SetVScrollBar(GetLongProp("VScrollBar"));

	// AutoCompletion
	if(GetTableProp("AutoCompletion")) {
		m_objCtrl->SetAutoCAutoHide(GetLongProp("AutoHide"));
		m_objCtrl->SetAutoCCancelAtStart(GetLongProp("CancelAtStart"));
		m_objCtrl->SetAutoCChooseSingle(GetLongProp("ChooseSingle"));
		m_objCtrl->SetAutoCDropRestOfWord(GetLongProp("DropRestOfWord"));
		m_objCtrl->SetAutoCIgnoreCase(GetLongProp("IgnoreCase"));
		LPCTSTR str = GetStringProp("Separator", " ");
		m_objCtrl->SetAutoCSeparator(str[0]);
		str = GetStringProp("SeparatorType", "?");
		m_objCtrl->SetAutoCTypeSeparator(str[0]);
		lua_pop(m_L, 1);
	}

	// Calltips
	if(GetTableProp("Calltips")) {
		if(GetTableProp("Fore")) {
			m_objCtrl->CallTipSetFore(GetRGB());
		}
		if(GetTableProp("Back")) {
			m_objCtrl->CallTipSetBack(GetRGB());
		}
		if(GetTableProp("Highlight")) {
			m_objCtrl->CallTipSetForeHlt(GetRGB());
		}
		lua_pop(m_L, 1);
	}

	if(GetTableProp("XCaretPolicy")) {
		m_objCtrl->SetXCaretPolicy(GetLongProp("policy"), GetLongProp("slop"));
		lua_pop(m_L, 1);
	}
	if(GetTableProp("YCaretPolicy")) {
		m_objCtrl->SetYCaretPolicy(GetLongProp("policy"), GetLongProp("slop"));
		lua_pop(m_L, 1);
	}
	if(GetTableProp("VisiblePolicy")) {
		m_objCtrl->SetVisiblePolicy(GetLongProp("policy"), GetLongProp("slop"));
		lua_pop(m_L, 1);
	}
	m_objCtrl->SetViewWS(GetLongProp("ViewWhiteSpace"));
	if(GetTableProp("WhiteSpaceFore")) {
		m_objCtrl->SetWhiteSpaceFore(true, GetRGB());
	}
	if(GetTableProp("WhiteSpaceBack")) {
		m_objCtrl->SetWhiteSpaceBack(true, GetRGB());
	}
	m_objCtrl->SetViewEOL(GetLongProp("ViewEOL"));
	m_objCtrl->SetEOLMode(GetLongProp("EOLMode"));
	m_objCtrl->SetUndoCollection(GetLongProp("UndoCollection", 1));
	if(GetTableProp("SelectionFore")) {
		m_objCtrl->SetSelFore(true, GetRGB());
	}
	if(GetTableProp("SelectionBack")) {
		m_objCtrl->SetSelBack(true, GetRGB());
	}
	if(GetTableProp("Caret")) {
		if(GetTableProp("Fore")) {
			m_objCtrl->SetCaretFore(GetRGB());
		}
		if(GetTableProp("Back")) {
			m_objCtrl->SetCaretLineBack(GetRGB());
		}
		m_objCtrl->SetCaretLineVisible(GetLongProp("LineVisible", TRUE));
		m_objCtrl->SetCaretPeriod(GetLongProp("Period", 500));
		m_objCtrl->SetCaretWidth(GetLongProp("Width", 1));
		lua_pop(m_L, 1);
	}
	if(GetTableProp("HotSpot")) {
		if(GetTableProp("Fore")) {
			m_objCtrl->SetHotSpotActiveFore(true, GetRGB());
		}
		if(GetTableProp("Back")) {
			m_objCtrl->SetHotSpotActiveBack(true, GetRGB());
		}
		m_objCtrl->SetHotSpotActiveUnderline(GetLongProp("Underline", TRUE));
		lua_pop(m_L, 1);
	}
	if(GetTableProp("Margins")) {
		char buffer[20];
		for(int i = 0; i <= 2; i++) {
			wsprintf(buffer, "Margin%i", i);
			if(GetTableProp(buffer)) {
				m_objCtrl->SetMarginTypeN(i, GetLongProp("Type"));
				m_objCtrl->SetMarginWidthN(i, GetLongProp("Width"));
				m_objCtrl->SetMarginMaskN(i, GetLongProp("Mask"));
				m_objCtrl->SetMarginSensitiveN(i, GetLongProp("Sensitive"));
				lua_pop(m_L, 1);
			}
		}
		m_objCtrl->SetMarginLeft(GetLongProp("Left", 1));
		m_objCtrl->SetMarginRight(GetLongProp("Right", 1));
		if(GetTableProp("FoldColour")) {
			m_objCtrl->SetFoldMarginColour(true, GetRGB());
		}
		lua_pop(m_L, 1);
	}
	m_objCtrl->SetBufferedDraw(GetLongProp("BufferedDraw"));
	m_objCtrl->SetTwoPhaseDraw(GetLongProp("TwoPhaseDraw"));
	m_objCtrl->SetCodePage(GetLongProp("CodePage"));
	// Falta el SETWORDCHARS
	m_objCtrl->SetWordChars(0, GetStringProp("WordChars", NULL));
	if(GetTableProp("Indentation")) {
		m_objCtrl->SetTabWidth(GetLongProp("TabWidth", 8));
		m_objCtrl->SetUseTabs(GetLongProp("UseTabs", 1));
		m_objCtrl->SetIndent(GetLongProp("Indent"));
		m_objCtrl->SetTabIndents(GetLongProp("TabIndents"));
		m_objCtrl->SetBackSpaceUnIndents(GetLongProp("BackSpaceUnIndents"));
		m_objCtrl->SetIndentationGuides(GetLongProp("IndentationGuides"));
		m_objCtrl->SetAutoIndent(GetLongProp("AutoIndentation", FALSE));
		m_objCtrl->SetMaintainIndent(GetLongProp("MaintainIndentation", FALSE));
		if(GetTableProp("StatementStart")) {
			m_objCtrl->SetAutoIndentStatementStart(GetLongProp("style", 5), GetStringProp("words", ""));
			lua_pop(m_L, 1);
		}
		if(GetTableProp("StatementEnd")) {
			m_objCtrl->SetAutoIndentStatementEnd(GetLongProp("style", 5), GetStringProp("words", ""));
			lua_pop(m_L, 1);
		}
		if(GetTableProp("BlockStart")) {
			m_objCtrl->SetAutoIndentBlockStart(GetLongProp("style", 5), GetStringProp("words", ""));
			lua_pop(m_L, 1);
		}
		if(GetTableProp("BlockEnd")) {
			m_objCtrl->SetAutoIndentBlockEnd(GetLongProp("style", 5), GetStringProp("words", ""));
			lua_pop(m_L, 1);
		}

		if(GetTableProp("Back")) {
			m_objCtrl->SetCaretLineBack(GetRGB());
		}
		m_objCtrl->SetCaretLineVisible(GetLongProp("LineVisible", TRUE));
		m_objCtrl->SetCaretPeriod(GetLongProp("Period", 500));
		m_objCtrl->SetCaretWidth(GetLongProp("Width", 1));
		lua_pop(m_L, 1);
	}
	if(GetTableProp("Markers")) {
		BeginIterarTabla();
		while(IterarTabla()) {
			int iMarker = GetLongProp("number");
			m_objCtrl->MarkerDefine(iMarker, GetLongProp("Symbols"));
			LPCTSTR str = GetStringProp("Pixmap");
			if(str && lstrlen(str)) {
				m_objCtrl->MarkerDefinePixMap(iMarker, str);
			}
			if(GetTableProp("Fore")) {
				m_objCtrl->MarkerSetFore(iMarker, GetRGB());
			}
			if(GetTableProp("Back")) {
				m_objCtrl->MarkerSetBack(iMarker, GetRGB());
			}
			LoopIterarTabla();
		}
		lua_pop(m_L, 1);
	}
	if(GetTableProp("Folding")) {
		if(GetLongProp("Enabled", 0) != 0) {
			m_objCtrl->SetProperty_("fold", "1");
			long lMask = m_objCtrl->GetModEventMask();
			m_objCtrl->SetModEventMask(lMask | 0x8);	//SC_MOD_CHANGEFOLD
		}
		m_objCtrl->SetFoldFlags(GetLongProp("Flags", 0));
		lua_pop(m_L, 1);
	}

	if(GetTableProp("CompletionList")) {
		LPCTSTR strSep = "";
		LPCTSTR strSubSep = "";
		BeginIterarTabla();
		while(IterarTabla()) {
			LPCTSTR strPrefix = GetStringProp("Prefix");
			if(GetTableProp("Wordlist")) {
				BeginIterarTabla();
				CString strValor = strSep; strValor += strSubSep;
				while(IterarTabla()) {
					if(lua_istable(m_L, -1)) {
						BeginIterarTabla();
						while(IterarTabla()) {
							if(lua_isstring(m_L, -1)) {
								strValor += lua_tostring(m_L, -1);
								LoopIterarTabla();
								if(IterarTabla()) {
									strValor += strSubSep;
									strValor += lua_tostring(m_L, -1);
									LoopIterarTabla();
								}
								else {
									break;
								}
							}
							else {
								LoopIterarTabla();
							}
						}
						strValor += strSep;
					}
					LoopIterarTabla();
				}
				LoopIterarTabla();
				m_objCtrl->SetCompletionList(strPrefix, strValor);
			}
			LoopIterarTabla();
		}
		lua_pop(m_L, 1);
	}

	// Obtener las keywords
	if(GetTableProp("Keywords")) {
		BeginIterarTabla();
		LPCTSTR strValor;
		int iClave;
		while(IterarTabla()) {
			switch(lua_type(m_L, -1)) {
				case LUA_TNUMBER:
					iClave = lua_tonumber(m_L, -1);
				break;
				case LUA_TSTRING:
					strValor = lua_tostring(m_L, -1);
					m_objCtrl->SetKeyWords(iClave, strValor);
				break;
			}
			LoopIterarTabla();
		}
		lua_pop(m_L, 1);
	}	
	lua_pop(m_L, 1);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
/// 
int CEvalScintilla::RunFile(LPCTSTR fullFileName) {
	HANDLE hFile = CreateFile(fullFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	DWORD size = GetFileSize(hFile, NULL);
	char* buffer = new char[size + 1];
	DWORD readLenght;
	ReadFile(hFile, buffer, size, &readLenght, NULL);
	buffer[size] = NULL;
	int result = dostring(buffer);
	delete[] buffer;
	CloseHandle(hFile);
	return result;
}

//////////////////////////////////////////////////////////////////////
/// Trae un elemento como LPCTSTR de una tabla en el tope del stack
LPCTSTR CEvalScintilla::GetStringProp(LPCTSTR strName, LPCTSTR strDefVal/* = ""*/) {
	LPCTSTR str;
	lua_pushstring(m_L, strName);
	lua_gettable(m_L, -2);
	if(lua_type(m_L, -1) != LUA_TSTRING) {
		lua_pop(m_L, 1);
		return strDefVal;
	}
	str = lua_tostring(m_L, -1);
	lua_pop(m_L, 1);
	return str;
}

//////////////////////////////////////////////////////////////////////
// Trae un elemento como long de una tabla en el tope del stack
long CEvalScintilla::GetLongProp(LPCTSTR strName, long lDefVal/* = 0*/) {
	long l;
	lua_pushstring(m_L, strName);
	lua_gettable(m_L, -2);
	if(lua_type(m_L, -1) != LUA_TNUMBER) {
		lua_pop(m_L, 1);
		return lDefVal;
	}
	l = lua_tonumber(m_L, -1);
	lua_pop(m_L, 1);
	return l;
}

//////////////////////////////////////////////////////////////////////
// Trae un elemento como tabla de una tabla en el tope del stack, y la deja ahi
BOOL CEvalScintilla::GetTableProp(LPCTSTR strName) {
	lua_pushstring(m_L, strName);
	lua_gettable(m_L, -2);
	if(lua_type(m_L, -1) != LUA_TTABLE) {
		lua_pop(m_L, 1);
		return FALSE;
	}
	return TRUE;
}