#include "stdafx.h"
#include "EvaluadorLUA.h"

//////////////////////////////////////////////////////////////////////
// Constructor
CEvaluadorLUA::CEvaluadorLUA() {
	/*L = lua_open(0);
	if(L) {
		lua_baselibopen(L);
		lua_pushnumber(L, (long)this);
		lua_setglobal(L, _T("lua_object"));
		//lua_strlibopen(L);
		//lua_iolibopen(L);
		//lua_mathlibopen(L);
		REG_LUAFUNC(CEvaluadorLUA, errormessage, LUA_ERRORMESSAGE)
	}*/

	////PREG_LUAFUNC(CEvaluadorLUA, errormessage, LUA_ERRORMESSAGE)
}

//////////////////////////////////////////////////////////////////////
// Destructor
CEvaluadorLUA::~CEvaluadorLUA() {
	//lua_close(L);
}

//////////////////////////////////////////////////////////////////////
// Mensajes de error tirados desde LUA
/*IMPL_LUAFUNC(CEvaluadorLUA, errormessage) {
	LPCTSTR str = lua_tostring(L, 1);
	if (str == NULL) {
		str = _T("(no message)");
	}
	//Log(str);
	OutputDebugString(str);
	OutputDebugString(_T("\n"));
	lua_settop(L, 0);
	return 0;
}*/

//////////////////////////////////////////////////////////////////////
// Recupera el retorno del script
bool CEvaluadorLUA::GetCodeReturn(LPTSTR* strRet) {
	int iTop = lua_gettop(m_L);
	*strRet = NULL;

	if(iTop == 0) {
		OutputDebugString(_T("CEvaluadorLUA::GetCodeReturn - No se pasaron parmetros\n"));
		return true;
	}
	int iType = lua_type(m_L, iTop);

	switch(iType) {
	case LUA_TNONE:
		OutputDebugString(_T("Evaluador::GetCodeReturn - No hay retorno"));
		return false;
	break;

	case LUA_TUSERDATA:
		OutputDebugString(_T("Evaluador::GetCodeReturn - El tipo 'userdata' no es soportado en el retorno"));
		lua_settop(m_L, 0);
		return false;
	break;

	case LUA_TNIL:
		*strRet = (TCHAR*)malloc(6 * sizeof(TCHAR));
		lstrcpy(*strRet, _T("false"));
		lua_settop(m_L, 0);
		return false;
	break;

	case LUA_TNUMBER: {
		CString strTemp;
		double dNum = lua_tonumber(m_L, -1);
		strTemp.Format(_T("%i"), (int)dNum);
		lua_settop(m_L, 0);
		*strRet = (TCHAR*)malloc(strTemp.GetLength() + sizeof(TCHAR));
		lstrcpy(*strRet, strTemp);
		return true;
	break;}

	case LUA_TSTRING:
		*strRet = _tcsdup(lua_tostring(m_L, -1));
		lua_settop(m_L, 0);
		return true;
	break;

	case LUA_TTABLE:
		OutputDebugString(_T("Evaluador::GetCodeReturn - El tipo 'table' no es soportado en el retorno"));
		lua_settop(m_L, 0);
		return false;
	break;

	case LUA_TFUNCTION:
		OutputDebugString(_T("Evaluador::GetCodeReturn - El tipo 'function' no es soportado en el retorno"));
		lua_settop(m_L, 0);
		return false;
	break;

	default:
		OutputDebugString(_T("Evaluador::GetCodeReturn - Tipo desconocido en el retorno"));
		lua_settop(m_L, 0);
		break;
	}
	return false;
}

/*//////////////////////////////////////////////////////////////////////
// Engancha LUA con CInteractionBase
void CEvaluadorLUA::HookPointer(void* ptr, LPCTSTR strNomGlobal) {
	// Meto el puntero en el stack
	lua_pushnumber(L, (double)(DWORD)ptr);
	// Ahora lo asigno a la variable global strNomGlobal
	lua_setglobal(L, strNomGlobal);
}
*/

//////////////////////////////////////////////////////////////////////
/// Trae un elemento como LPCTSTR de una tabla en el tope del stack
LPCTSTR CEvaluadorLUA::GetStringProp(LPCTSTR strName, LPCTSTR strDefVal/* = ""*/) {
	LPCTSTR str;
	lua_pushstring(m_L, strName);
	lua_gettable(m_L, -2);
	if(lua_type(m_L, -1) != LUA_TSTRING) {
		lua_pop(m_L, 1);
		return strDefVal;
	}
	str = lua_tostring(m_L, -1);
	lua_pop(m_L, 1);
	return str;
}

//////////////////////////////////////////////////////////////////////
// Trae un elemento como long de una tabla en el tope del stack
long CEvaluadorLUA::GetLongProp(LPCTSTR strName, long lDefVal/* = 0*/) {
	long l;
	lua_pushstring(m_L, strName);
	lua_gettable(m_L, -2);
	if(lua_type(m_L, -1) != LUA_TNUMBER) {
		lua_pop(m_L, 1);
		return lDefVal;
	}
	l = lua_tonumber(m_L, -1);
	lua_pop(m_L, 1);
	return l;
}

//////////////////////////////////////////////////////////////////////
// Trae un elemento como tabla de una tabla en el tope del stack, y la deja ahi
BOOL CEvaluadorLUA::GetTableProp(LPCTSTR strName) {
	lua_pushstring(m_L, strName);
	lua_gettable(m_L, -2);
	if(lua_type(m_L, -1) != LUA_TTABLE) {
		lua_pop(m_L, 1);
		return FALSE;
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
/// 
int CEvaluadorLUA::RunFile(LPCTSTR fullFileName) {
	HANDLE hFile = CreateFile(fullFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	DWORD size = GetFileSize(hFile, NULL);
	char* buffer = new char[size + 1];
	DWORD readLenght;
	ReadFile(hFile, buffer, size, &readLenght, NULL);
	buffer[size] = NULL;
	int result = dostring(buffer);
	delete[] buffer;
	CloseHandle(hFile);
	return result;
}
