#include "stdafx.h"
#include "compintdesigner.h"
#include "EventosMWListCtrl.h"
#include "Domain\EventosMW.h"

#define NUM_COLUMNAS 4

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNAMIC(CEventosMWListCtrl, CMyListCtrl)

CEventosMWListCtrl::CEventosMWListCtrl() {
	m_oldSortAscending = false;
	m_bCustomDraw = true;
}

CEventosMWListCtrl::~CEventosMWListCtrl() {

}

BEGIN_MESSAGE_MAP(CEventosMWListCtrl, CMyListCtrl) 
   ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick) 
   ON_WM_SIZE()
   //ON_NOTIFY_REFLECT(NM_DBLCLK, OnNMLdblclk)
   ON_WM_CONTEXTMENU()
END_MESSAGE_MAP()


//////////////////////////////////////////////////////////////////////
// 
bool CEventosMWListCtrl::Init() {
	CRect rect;

	SetExtendedStyle(LVS_EX_FULLROWSELECT/* | LVS_EX_GRIDLINES*/);
	ModifyStyle(NULL, LVS_SHOWSELALWAYS);

	GetClientRect(rect);
	int iSize = rect.Width() / NUM_COLUMNAS;

	InsertColumn(0, "Event", LVCFMT_CENTER, iSize);
	InsertColumn(1, "Message", LVCFMT_CENTER, iSize);
	InsertColumn(2, "Asynchronous", LVCFMT_CENTER, iSize);
	InsertColumn(3, "Dump", LVCFMT_CENTER, iSize);

	return true;
}

//////////////////////////////////////////////////////////////////////
// 
void CEventosMWListCtrl::OnSize(UINT nType, int cx, int cy) {
	SetRedraw(FALSE);
	int iSize = cx / NUM_COLUMNAS;
	for(int i = 0; i < NUM_COLUMNAS; i++) {
		SetColumnWidth(i, iSize);
	}
	CMyListCtrl::OnSize(nType, cx, cy);
	SetRedraw(TRUE);
}

//////////////////////////////////////////////////////////////////////
// 
void CEventosMWListCtrl::OnColumnClick(NMHDR *pNMHDR, LRESULT *pResult) {
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR; 

	if(!GetItemCount()) return;
	// Item is column clicked
	int sortItem = pNMListView->iSubItem;
	if(sortItem >= 2) {
		// Solo ordeno por las dos primeras
		return;
	}
	// Sort table
	m_oldSortAscending = !m_oldSortAscending;
	SetSortArrow(sortItem, m_oldSortAscending);
	SortItems(SortProc, sortItem + (m_oldSortAscending ? 0:100));
	this->Invalidate();
	*pResult = 0; 
}

//////////////////////////////////////////////////////////////////////
// 
int CEventosMWListCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort){ 
	CEventoMW* evt1 = (CEventoMW*)lParam1;
	CEventoMW* evt2 = (CEventoMW*)lParam2;
	if((evt1 == NULL) || (evt2 == NULL)) {
		return 0;
	}
	
	switch(lParamSort) {
		case 0:	// Sort ascendente
			return _tcsicmp(evt1->GetID(), evt2->GetID());
		break;

		case 100:	// Sort descendente
			return _tcsicmp(evt2->GetID(), evt1->GetID());
		break;

		case 1:	// Sort ascendente
			return _tcsicmp(evt1->GetIDMensaje(), evt2->GetIDMensaje());
		break;

		case 101:	// Sort descendente
			return _tcsicmp(evt2->GetIDMensaje(), evt1->GetIDMensaje());
		break;
	}
	return 0;
}

/*//////////////////////////////////////////////////////////////////////
// 
void CEventosMWListCtrl::OnNMLdblclk(NMHDR *pNMHDR, LRESULT *pResult){ // mod bb 27.09.02
	if(GetSelectionMark() != (-1)) {
		//theApp.serverconnect->ConnectToServer((CServer*)GetItemData(GetSelectionMark())); 
	   //theApp.emuledlg->ShowConnectionState(false);
	}
}*/

//////////////////////////////////////////////////////////////////////
// 
int CEventosMWListCtrl::GetSelected(CEventoMW** p_oEvt) {
	int nSel = GetNextItem(-1, LVNI_SELECTED);
	if(nSel == -1) {
		*p_oEvt = NULL;
		return nSel;
	}
	*p_oEvt = (CEventoMW*)GetItemData(nSel);
	return nSel;
}

//////////////////////////////////////////////////////////////////////
// 
int CEventosMWListCtrl::Add(CEventoMW* oEvt, bool bSelect) {
	int iItem = InsertItem(0, oEvt->GetID());
	SetItemText(iItem, 1, oEvt->GetIDMensaje());
	SetItemText(iItem, 2, oEvt->GetAsyncStr());
	SetItemText(iItem, 3, oEvt->GetDumpResultStr());
	SetItemData(iItem, (DWORD)oEvt);
	if(bSelect) {
		SetItemState(iItem, LVIS_SELECTED, LVIS_SELECTED);
	}
	return iItem;
}

//////////////////////////////////////////////////////////////////////
// 
void CEventosMWListCtrl::OnContextMenu(CWnd* pWnd, CPoint point) {
	CMenu menu;
	// fix - on right click, we also want to change the current selection like the left click does 
	CPoint p = point;
	ScreenToClient(&p);
	int it = HitTest(p);
	if(it != -1) {
      SetSelectionMark(it);   // display selection mark correctly! 
	}
	// fix end 
	menu.CreatePopupMenu();
	menu.AppendMenu(MF_STRING, IDC_BUTTON_ADD_MW, "Add");
	menu.AppendMenu(MF_STRING, IDC_BUTTON_EDIT_MW, "Edit");
	menu.AppendMenu(MF_STRING, IDC_BUTTON_REMOVE_MW, "Remove");

	menu.TrackPopupMenu(TPM_LEFTALIGN, point.x, point.y, GetParent());
}