#include "stdafx.h"
#include "FolderBrowser.h"
#include <Shlobj.h>
#include <comdef.h>
#include <MyKey.h>
#include "Domain\Globales.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFolderBrowser::CFolderBrowser() :
	m_preselectLastUsedFolder(false), m_rememberSelectedFolder(false)
{

}

CFolderBrowser::~CFolderBrowser()
{

}

//////////////////////////////////////////////////////////////////////////
/// 
void CFolderBrowser::RemeberSelected() {
	m_rememberSelectedFolder = true;
}

//////////////////////////////////////////////////////////////////////////
/// 
void CFolderBrowser::PreSelectLastUsedFolder() {
	CMyKey objKey;
	objKey.OpenCreate(APP_NAME, _T("UserSettings"), HKEY_CURRENT_USER);
	objKey.GetCreateValue(_T("LastSelectedFolder"), m_lastUsedFolder, _T(""));

	if(m_lastUsedFolder != "") {
		m_preselectLastUsedFolder = true;
	}
}

//////////////////////////////////////////////////////////////////////////
/// 
void CFolderBrowser::RememberFolder(LPCTSTR selectedFolder) {
	if(m_rememberSelectedFolder) {
		CMyKey objKey;
		objKey.OpenCreate(APP_NAME, _T("UserSettings"), HKEY_CURRENT_USER);
		objKey.SetCreateValue(_T("LastSelectedFolder"), selectedFolder);
	}
}

//////////////////////////////////////////////////////////////////////////
/// 
static int CALLBACK BrowseDirectoryProc(HWND hwnd, UINT uMsg, LPARAM lp, LPARAM pData) {
	CFolderBrowser* object = (CFolderBrowser*)pData;
	return object->__BrowseDirectoryProc(hwnd, uMsg, lp);
}

//////////////////////////////////////////////////////////////////////////
/// 
int CFolderBrowser::__BrowseDirectoryProc(HWND hwnd, UINT uMsg, LPARAM lp) {
	TCHAR szDir[MAX_PATH];

	switch(uMsg) {
		case BFFM_INITIALIZED: {
			if(m_preselectLastUsedFolder) {
				SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)(LPCTSTR)m_lastUsedFolder);
			}
			else if(GetCurrentDirectory(sizeof(szDir) / sizeof(TCHAR), szDir)) {
				// WParam is TRUE since you are passing a path.
				// It would be FALSE if you were passing a pidl.
				SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)szDir);
			}
			break;
		}

		case BFFM_SELCHANGED: {
			// Set the status window to the currently selected path.
			if (SHGetPathFromIDList((LPITEMIDLIST)lp, szDir)) {
				SendMessage(hwnd, BFFM_SETSTATUSTEXT, 0, (LPARAM)szDir);
			}
			break;
		}
		default:
		break;
	}	
	return 0;
}

//////////////////////////////////////////////////////////////////////////
/// 
bool CFolderBrowser::Show(HWND ownerWindow, CString& selectedFolder) {
	BROWSEINFO bi;
	TCHAR szDir[MAX_PATH];
	LPITEMIDLIST pidl;
	IMallocPtr pMalloc;

	selectedFolder = "";

	if(SUCCEEDED(SHGetMalloc(&pMalloc))) {
		ZeroMemory(&bi, sizeof(bi));
		bi.hwndOwner = ownerWindow;
		bi.pszDisplayName = 0;

		bi.pidlRoot = 0;
		bi.ulFlags = BIF_USENEWUI;
		bi.lpfn = BrowseDirectoryProc;
		bi.lParam = (LPARAM)this;
		TCHAR* pszRetVal = new TCHAR[MAX_PATH + 1];
		ZeroMemory(pszRetVal, MAX_PATH * sizeof(TCHAR));
		bi.pszDisplayName = pszRetVal;
		pidl = SHBrowseForFolder(&bi);
		if(pidl) {
			if(SHGetPathFromIDList(pidl, szDir)) {
				pMalloc->Free(pidl);
				delete pszRetVal;
				selectedFolder = szDir;
				RememberFolder(szDir);
				return true;
			}
		}
		pMalloc->Free(pidl);
		delete pszRetVal;
	}
	return false;
}
