#include "stdafx.h"
#include "compintdesigner.h"
#include "FormWkiEventoMW.h"
#include "ViewCommand.h"
#include "Domain\EventoMW.h"
#include "DlgWkiEventoMWIuff.h"
#include "WorkitemView.h"
#include "Domain\Globales.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormWkiEventoMW

IMPLEMENT_DYNCREATE(CFormWkiEventoMW, cdxCDynamicFormView)

CFormWkiEventoMW::CFormWkiEventoMW()
	: cdxCDynamicFormView(CFormWkiEventoMW::IDD)
{
	//{{AFX_DATA_INIT(CFormWkiEventoMW)
	//}}AFX_DATA_INIT
	m_objEventoMW = NULL;
}

CFormWkiEventoMW::~CFormWkiEventoMW()
{
}

void CFormWkiEventoMW::DoDataExchange(CDataExchange* pDX) {
	cdxCDynamicFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFormWkiEventoMW)
	DDX_Control(pDX, IDC_FRAME_IUFFS, m_frameIuffs);
	DDX_Control(pDX, IDC_FRAME_1, m_frameSuperior);
	DDX_Control(pDX, IDC_EDIT_MESSAGE, m_edtMessage);
	DDX_Control(pDX, IDC_EDIT_EVENT, m_edtEvent);
	DDX_Control(pDX, IDC_CHECK_DUMP_RESULT, m_chkDumpResult);
	DDX_Control(pDX, IDC_CHECK_ASYNC, m_chkAsync);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btnRemove);
	DDX_Control(pDX, IDC_BUTTON_EDIT, m_btnEdit);
	DDX_Control(pDX, IDC_BUTTON_ADD, m_btnAdd);
	DDX_Control(pDX, IDC_LIST_IUFFS, m_lstIuffs);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFormWkiEventoMW, cdxCDynamicFormView)
	//{{AFX_MSG_MAP(CFormWkiEventoMW)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_IUFFS, OnDblclkListIuffs)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_EDIT, OnButtonEdit)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DYNAMIC_MAP(CFormWkiEventoMW, cdxCDynamicFormView)
	DYNAMIC_MAP_ENTRY(IDC_FRAME_1, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_FRAME_IUFFS, mdResize, mdResize)
	DYNAMIC_MAP_ENTRY(IDC_PICTURE_2, mdRepos, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_LIST_IUFFS, mdResize, mdResize)

	DYNAMIC_MAP_ENTRY(IDC_CHECK_ASYNC, mdRepos, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_CHECK_DUMP_RESULT, mdRepos, mdNone)
	
	DYNAMIC_MAP_ENTRY(IDC_EDIT_EVENT, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_EDIT_MESSAGE, mdResize, mdNone)

	DYNAMIC_MAP_ENTRY(IDC_BUTTON_ADD, mdRepos, mdRepos)
	DYNAMIC_MAP_ENTRY(IDC_BUTTON_EDIT, mdRepos, mdRepos)
	DYNAMIC_MAP_ENTRY(IDC_BUTTON_REMOVE, mdRepos, mdRepos)
END_DYNAMIC_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormWkiEventoMW diagnostics

#ifdef _DEBUG
void CFormWkiEventoMW::AssertValid() const {
	cdxCDynamicFormView::AssertValid();
}

void CFormWkiEventoMW::Dump(CDumpContext& dc) const {
	cdxCDynamicFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFormWkiEventoMW message handlers

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventoMW::SetEventoMW(CEventoMW* p_objEventoMW) {
	m_objEventoMW = p_objEventoMW;
}

//////////////////////////////////////////////////////////////////////
// 
BOOL CFormWkiEventoMW::OnDataUpdate(CViewCommand* p_Command) {
	switch(p_Command->GetCommandType()) {
		case COMMAND_UPDATE_EVT_MW:
			SetEventoMW((CEventoMW*)(p_Command->GetData()));
			RefreshEvento();
		break;

		case COMMAND_UPDATE_ALL:
			/*m_lstDevices.DeleteAllItems();
			m_treeGrupos.DeleteAllItems();
			LlenarListaDevices();
			LlenarListaGrupos();*/
		break;

		case COMMAND_UPDATE_DEFWORKITEM: {
			/*SetWorkitem((CDefWorkitem*)p_Command->GetData());
			LlenarListaEventos();
			CEventosMW& objEvts = m_objDefWki->GetEventosMW();
			m_edtPetition.SetWindowText(objEvts.GetPeticion());
			m_edtVersion.SetWindowText(objEvts.GetVersion());
			m_edtOrigin.SetWindowText(objEvts.GetOrigen());*/
		break;}
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventoMW::OnInitialUpdate() {
	cdxCDynamicFormView::OnInitialUpdate();

	m_lstIuffs.Init();
	
	m_frameSuperior.SetIcon(IDI_ICON_INFO);
	m_frameIuffs.SetIcon(IDI_ICON_MESSAGE);

	m_btnAdd.SetIcon(IDI_ICON_ABM_ADD, (int)BTNST_AUTO_GRAY);
	m_btnEdit.SetIcon(IDI_ICON_ABM_EDIT, (int)BTNST_AUTO_GRAY);
	m_btnRemove.SetIcon(IDI_ICON_ABM_REMOVE, (int)BTNST_AUTO_GRAY);
	m_btnAdd.SetTooltipText("Add Iuff");
	m_btnEdit.SetTooltipText("Edit Iuff");
	m_btnRemove.SetTooltipText("Remove Iuff");
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventoMW::RefreshEvento() {
	m_edtEvent.SetWindowText(m_objEventoMW->GetID());
	m_edtMessage.SetWindowText(m_objEventoMW->GetIDMensaje());
	if(m_objEventoMW->GetDumpResult()) {
		m_chkDumpResult.SetCheck(BST_CHECKED);
	}
	else {
		m_chkDumpResult.SetCheck(BST_UNCHECKED);
	}
	if(m_objEventoMW->GetAsync()) {
		m_chkAsync.SetCheck(BST_CHECKED);
	}
	else {
		m_chkAsync.SetCheck(BST_UNCHECKED);
	}
	// Llenar la lista de Iuffs
	LlenarListaDeIuffs();
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventoMW::LlenarListaDeIuffs() {
	m_lstIuffs.DeleteAllItems();
	
	CMyMapIterador<CIuff*>* iterador =  m_objEventoMW->GetIuffs();
	if(iterador->begin()) {
		while(*iterador) {
			m_lstIuffs.Add((*iterador)++, false);
		}
	}
	delete iterador;
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventoMW::OnDblclkListIuffs(NMHDR* pNMHDR, LRESULT* pResult) {
	OnButtonEdit();
	*pResult = 0;
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventoMW::OnButtonAdd() {
	CIuff* oIuff = new CIuff;
	CDlgWkiEventoMWIuff dlg;
	dlg.SetIuff(oIuff);
	if(dlg.DoModal() != IDOK) {
		delete oIuff;
		return;
	}
	m_lstIuffs.Add(oIuff, true);
	m_objEventoMW->AddIuff(oIuff);
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventoMW::OnButtonEdit() {
	int iSel = m_lstIuffs.GetNextItem(-1, LVNI_SELECTED);
	if(iSel == -1) {
		return;
	}
	CIuff* oIuff;
	oIuff = (CIuff*)m_lstIuffs.GetItemData(iSel);
	CDlgWkiEventoMWIuff dlg;
	dlg.SetIuff(oIuff);
	if(dlg.DoModal() != IDOK) {
		return;
	}
	LlenarListaDeIuffs();
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventoMW::OnButtonRemove() {
	int iSel = m_lstIuffs.GetNextItem(-1, LVNI_SELECTED);
	if(iSel == -1) {
		return;
	}
	CIuff* oIuff;
	oIuff = (CIuff*)m_lstIuffs.GetItemData(iSel);
	m_objEventoMW->DeleteIuff(oIuff);
	LlenarListaDeIuffs();
}

//////////////////////////////////////////////////////////////////////
// Valido los campos
BOOL CFormWkiEventoMW::CanClose() {
	CString strData;

	m_edtEvent.GetWindowText(strData);
	strData.Replace(" ", "");
	if(strData.GetLength() == 0) {
		AfxMessageBox("You must supply a valid name for this event", MB_ICONERROR);
		return FALSE;
	}

	m_edtMessage.GetWindowText(strData);
	strData.Replace(" ", "");
	if(strData.GetLength() == 0) {
		AfxMessageBox("You must supply a valid message for this event", MB_ICONERROR);
		return FALSE;
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventoMW::UpdateEvento() {
	CString strData;

	m_edtEvent.GetWindowText(strData);
	m_objEventoMW->SetID(strData);
	m_edtMessage.GetWindowText(strData);
	m_objEventoMW->SetIDMensaje(strData);
	if(m_chkDumpResult.GetCheck() == BST_CHECKED) {
		m_objEventoMW->SetDumpResult("T");
	}
	else {
		m_objEventoMW->SetDumpResult("F");
	}
	if(m_chkAsync.GetCheck() == BST_CHECKED) {
		m_objEventoMW->SetAsync("T");
	}
	else {
		m_objEventoMW->SetAsync("F");
	}
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventoMW::OnClose() {
	UpdateEvento();
	// Mandar el update para que se actualice la info
	CViewCommand pComm(COMMAND_UPDATE_EVT_MW);
	pComm.SetData(m_objEventoMW);
	g_objViewManager->UpdateViews(this, &pComm);

	((CWorkitemView*)GetParentFrame())->OnMWEventPaneClosing(this);

	cdxCDynamicFormView::OnClose();
}
