#include "stdafx.h"
#include "CompIntDesigner.h"
#include "FormWkiEventosMW.h"
#include "ViewCommand.h"
#include "Domain\EventosMW.h"
#include "Domain\EventoMW.h"
#include "MainFrm.h"
#include <inputbox.h>
#include "WorkitemView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormWkiEventosMW

IMPLEMENT_DYNCREATE(CFormWkiEventosMW, cdxCDynamicFormView)

CFormWkiEventosMW::CFormWkiEventosMW()
	: cdxCDynamicFormView(CFormWkiEventosMW::IDD)
{
	//{{AFX_DATA_INIT(CFormWkiEventosMW)
	//}}AFX_DATA_INIT
}

CFormWkiEventosMW::~CFormWkiEventosMW() {}

void CFormWkiEventosMW::DoDataExchange(CDataExchange* pDX) {
	cdxCDynamicFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFormWkiEventosMW)
	DDX_Control(pDX, IDC_FRAME_MW_GENERAL, m_frameGeneral);
	DDX_Control(pDX, IDC_FRAME_MW_EVENTS, m_frameEventos);
	DDX_Control(pDX, IDC_LIST_EVENTS_MW, m_lstEventos);
	DDX_Control(pDX, IDC_EDIT_VERSION, m_edtVersion);
	DDX_Control(pDX, IDC_EDIT_PETITION, m_edtPetition);
	DDX_Control(pDX, IDC_EDIT_ORIGIN, m_edtOrigin);
	DDX_Control(pDX, IDC_BUTTON_REMOVE_MW, m_btnRemove);
	DDX_Control(pDX, IDC_BUTTON_EDIT_MW, m_btnEdit);
	DDX_Control(pDX, IDC_BUTTON_ADD_MW, m_btnAdd);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFormWkiEventosMW, cdxCDynamicFormView)
	//{{AFX_MSG_MAP(CFormWkiEventosMW)
	ON_BN_CLICKED(IDC_BUTTON_ADD_MW, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_EDIT_MW, OnButtonEdit)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_MW, OnButtonRemove)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_EVENTS_MW, OnDblclkListEventsMw)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DYNAMIC_MAP(CFormWkiEventosMW, cdxCDynamicFormView)
	DYNAMIC_MAP_ENTRY(IDC_FRAME_MW_GENERAL, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_FRAME_MW_EVENTS, mdResize, mdResize)
	DYNAMIC_MAP_ENTRY(IDC_PICTURE_MW, mdRepos, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_LIST_EVENTS_MW, mdResize, mdResize)

	DYNAMIC_MAP_ENTRY(IDC_STATIC_PETITION, mdNone, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_VERSION, mdRepos, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_ORIGIN, mdRepos, mdNone)
	
	DYNAMIC_MAP_ENTRY(IDC_EDIT_PETITION, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_EDIT_VERSION, mdRepos, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_EDIT_ORIGIN, mdRepos, mdNone)

	DYNAMIC_MAP_ENTRY(IDC_BUTTON_ADD_MW, mdRepos, mdRepos)
	DYNAMIC_MAP_ENTRY(IDC_BUTTON_EDIT_MW, mdRepos, mdRepos)
	DYNAMIC_MAP_ENTRY(IDC_BUTTON_REMOVE_MW, mdRepos, mdRepos)
END_DYNAMIC_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormWkiEventosMW diagnostics

#ifdef _DEBUG
void CFormWkiEventosMW::AssertValid() const
{
	cdxCDynamicFormView::AssertValid();
}

void CFormWkiEventosMW::Dump(CDumpContext& dc) const
{
	cdxCDynamicFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFormWkiEventosMW message handlers

void CFormWkiEventosMW::OnInitialUpdate() {
	cdxCDynamicFormView::OnInitialUpdate();
	
	m_lstEventos.Init();

	m_frameGeneral.SetIcon(IDI_ICON_INFO);
	m_frameEventos.SetIcon(IDI_ICON_SOBRE);

	m_btnAdd.SetIcon(IDI_ICON_ABM_ADD, (int)BTNST_AUTO_GRAY);
	m_btnEdit.SetIcon(IDI_ICON_ABM_EDIT, (int)BTNST_AUTO_GRAY);
	m_btnRemove.SetIcon(IDI_ICON_ABM_REMOVE, (int)BTNST_AUTO_GRAY);
	m_btnAdd.SetTooltipText("Add MW Event");
	m_btnEdit.SetTooltipText("Edit MW Event");
	m_btnRemove.SetTooltipText("Remove MW Event");
}


//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventosMW::LlenarListaEventos() {
	m_lstEventos.DeleteAllItems();
	
	CEventosMW& objEvts = m_objDefWki->GetEventosMW();
	CMyMapIterador<CEventoMW*>* iterador =  objEvts.GetEventos();
	if(iterador->begin()) {
		while(*iterador) {
			m_lstEventos.Add((*iterador)++, false);
		}
	}
	delete iterador;
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventosMW::SetWorkitem(CDefWorkitem* p_objWorkitem) {
	m_objDefWki = p_objWorkitem;
}

//////////////////////////////////////////////////////////////////////
// 
BOOL CFormWkiEventosMW::OnDataUpdate(CViewCommand* p_Command) {
	switch(p_Command->GetCommandType()) {
		case COMMAND_UPDATE_ALL:
			/*m_lstDevices.DeleteAllItems();
			m_treeGrupos.DeleteAllItems();
			LlenarListaDevices();
			LlenarListaGrupos();*/
		break;

		case COMMAND_UPDATE_DEFWORKITEM: {
			SetWorkitem((CDefWorkitem*)p_Command->GetData());
			LlenarListaEventos();
			CEventosMW& objEvts = m_objDefWki->GetEventosMW();
			m_edtPetition.SetWindowText(objEvts.GetPeticion());
			m_edtVersion.SetWindowText(objEvts.GetVersion());
			m_edtOrigin.SetWindowText(objEvts.GetOrigen());
		break;}

		case COMMAND_UPDATE_EVT_MW: {
			LlenarListaEventos();
		break; }
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventosMW::OnButtonAdd() {
	CInputBox objInpBox(m_hWnd);

	if(!objInpBox.DoModal("Add Middleware Event", "Enter the event name")) {
		return;
	}
	CEventoMW* oEvt =  new CEventoMW;
	oEvt->SetID(objInpBox.Text);
	m_objDefWki->GetEventosMW().AddEvento(oEvt);
	((CWorkitemView*)GetParentFrame())->AddMWEventPane(oEvt->GetID(), oEvt);
	LlenarListaEventos();
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventosMW::OnButtonEdit() {
	CEventoMW* oEvt;
	m_lstEventos.GetSelected(&oEvt);
	if(oEvt) {
		((CWorkitemView*)GetParentFrame())->AddMWEventPane(oEvt->GetID(), oEvt);
	}
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventosMW::OnButtonRemove() {
	CEventoMW* oEvt;
	if(m_lstEventos.GetSelected(&oEvt) == -1) {
		return;
	}
	m_objDefWki->GetEventosMW().RemoveEvento(oEvt);
	LlenarListaEventos();
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiEventosMW::OnDblclkListEventsMw(NMHDR* pNMHDR, LRESULT* pResult) {
	OnButtonEdit();
	*pResult = 0;
}

//////////////////////////////////////////////////////////////////////
// Actualiza los datos editados al workitem
bool CFormWkiEventosMW::UpdateWorkitem() {
	CString strTemp;
	CEventosMW& objEvts = m_objDefWki->GetEventosMW();

	m_edtPetition.GetWindowText(strTemp);
	objEvts.SetPeticion(strTemp);

	m_edtVersion.GetWindowText(strTemp);
	objEvts.SetVersion(strTemp);

	m_edtOrigin.GetWindowText(strTemp);
	objEvts.SetOrigen(strTemp);
	return true;
}