#include "stdafx.h"
#include "compintdesigner.h"
#include "FormWkiInfo.h"
#include "ViewCommand.h"
#include "Domain\Configuracion.h"
#include "Domain\Globales.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormWkiInfo

IMPLEMENT_DYNCREATE(CFormWkiInfo, cdxCDynamicFormView)

CFormWkiInfo::CFormWkiInfo()
	: cdxCDynamicFormView(CFormWkiInfo::IDD)
{
	//{{AFX_DATA_INIT(CFormWkiInfo)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_objDefWki = NULL;
}

CFormWkiInfo::~CFormWkiInfo() {}

void CFormWkiInfo::DoDataExchange(CDataExchange* pDX) {
	cdxCDynamicFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFormWkiInfo)
	DDX_Control(pDX, IDC_FRAME_WORKITEM, m_frameInfo);
	DDX_Control(pDX, IDC_EDIT_TYPE, m_edtType);
	DDX_Control(pDX, IDC_COMBO_BOUND_CHANNEL, m_cboBoundChannel);
	DDX_Control(pDX, IDC_EDIT_DESCRIPTION, m_edtDescription);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFormWkiInfo, cdxCDynamicFormView)
	//{{AFX_MSG_MAP(CFormWkiInfo)
	ON_WM_ENABLE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DYNAMIC_MAP(CFormWkiInfo, cdxCDynamicFormView)
	DYNAMIC_MAP_ENTRY(IDC_FRAME_WORKITEM, mdResize, mdResize)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_TYPE, mdNone, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_DESCRIPTION, mdNone, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_BOUNDCHANNEL, mdRepos, mdNone)
	
	DYNAMIC_MAP_ENTRY(IDC_EDIT_TYPE, mdNone, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_EDIT_DESCRIPTION, mdResize, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_COMBO_BOUND_CHANNEL, mdRepos, mdNone)
END_DYNAMIC_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormWkiInfo diagnostics

#ifdef _DEBUG
void CFormWkiInfo::AssertValid() const {
	cdxCDynamicFormView::AssertValid();
}

void CFormWkiInfo::Dump(CDumpContext& dc) const {
	cdxCDynamicFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFormWkiInfo message handlers

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiInfo::OnInitialUpdate() {
	cdxCDynamicFormView::OnInitialUpdate();
	m_frameInfo.SetIcon(IDI_ICON_INFO);

	m_edtType.EnableWindow(FALSE);
}

//////////////////////////////////////////////////////////////////////
// 
BOOL CFormWkiInfo::OnDataUpdate(CViewCommand* p_Command) {
	switch(p_Command->GetCommandType()) {
		case COMMAND_UPDATE_ALL:
			/*m_lstDevices.DeleteAllItems();
			m_treeGrupos.DeleteAllItems();
			LlenarListaDevices();
			LlenarListaGrupos();*/
		break;

		case COMMAND_UPDATE_DEFWORKITEM: {
			SetWorkitem((CDefWorkitem*)p_Command->GetData());
			LlenarDatos();
		break;}
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiInfo::SetWorkitem(CDefWorkitem* p_objWorkitem) {
	m_objDefWki = p_objWorkitem;
}

//////////////////////////////////////////////////////////////////////
//
void CFormWkiInfo::LlenarDatos() {
	CStringArray arrChans;

	m_cboBoundChannel.Clear();
	m_edtType.SetWindowText(m_objDefWki->GetTipo());
	m_edtDescription.SetWindowText(m_objDefWki->GetDescripcion());
	
	g_objConfig->GetBoundChannels(arrChans);
	for(int i = 0; i < arrChans.GetSize(); i++) {
		m_cboBoundChannel.AddString(arrChans.GetAt(i));
	}
	if(m_cboBoundChannel.SelectString(-1, m_objDefWki->GetCanalFisico()) == CB_ERR) {
		m_cboBoundChannel.SetCurSel(1);
	}
}

//////////////////////////////////////////////////////////////////////
// Actualiza los datos editados al workitem
bool CFormWkiInfo::UpdateWorkitem() {
	CString strTemp;

	if(m_cboBoundChannel.GetCurSel() == LB_ERR) {
		return false;
	}

	m_edtDescription.GetWindowText(strTemp);
	m_objDefWki->SetDescripcion(strTemp);

	m_cboBoundChannel.GetLBText(m_cboBoundChannel.GetCurSel(), strTemp);
	m_objDefWki->SetCanal(strTemp);
	return true;
}

/////////////////////////////////////////////////////////////////////////////
// Redefinido porque el framework me habilita todos los controles, sin importar
// lo que uno especifique inicialmente
void CFormWkiInfo::OnEnable(BOOL bEnable) {
	cdxCDynamicFormView::OnEnable(bEnable);
	m_edtType.EnableWindow(FALSE);
}