#include "stdafx.h"
#include "CompIntDesigner.h"
#include "FormWkiMetodos.h"
#include "ViewCommand.h"
#include "Domain\Metodo.h"
#include "InputBox.h"
#include "Domain\ScintillaWrapper.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormWkiMetodos

IMPLEMENT_DYNCREATE(CFormWkiMetodos, cdxCDynamicFormView)

CFormWkiMetodos::CFormWkiMetodos()
	: cdxCDynamicFormView(CFormWkiMetodos::IDD)
{
	//{{AFX_DATA_INIT(CFormWkiMetodos)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_objDefWki = NULL;
}

CFormWkiMetodos::~CFormWkiMetodos() {}

void CFormWkiMetodos::DoDataExchange(CDataExchange* pDX) {
	cdxCDynamicFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFormWkiMetodos)
	DDX_Control(pDX, IDC_FRAME_METODOS, m_frameMetodos);
	DDX_Control(pDX, IDC_BUTTON_REMOVE_METODO, m_btnRemove);
	DDX_Control(pDX, IDC_BUTTON_ADD_METODO, m_btnAdd);
	DDX_Control(pDX, IDC_LIST_METODOS, m_lstMetodos);
	DDX_Control(pDX, IDC_SCINTILLACTRL1, m_ctrlCodigo);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFormWkiMetodos, cdxCDynamicFormView)
	//{{AFX_MSG_MAP(CFormWkiMetodos)
	ON_BN_CLICKED(IDC_BUTTON_ADD_METODO, OnButtonAddMetodo)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_METODO, OnButtonRemoveMetodo)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_METODOS, OnItemChanged)
	ON_WM_ENABLE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DYNAMIC_MAP(CFormWkiMetodos, cdxCDynamicFormView)
	DYNAMIC_MAP_ENTRY(IDC_FRAME_METODOS, mdResize, mdResize)
	DYNAMIC_MAP_ENTRY(IDC_PICTURE_CODIGO, mdRepos, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_LIST_METODOS, mdNone, mdResize)

	DYNAMIC_MAP_ENTRY(IDC_BUTTON_ADD_METODO, mdRepos, mdRepos)
	DYNAMIC_MAP_ENTRY(IDC_BUTTON_REMOVE_METODO, mdRepos, mdRepos)
END_DYNAMIC_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormWkiMetodos diagnostics

#ifdef _DEBUG
void CFormWkiMetodos::AssertValid() const
{
	cdxCDynamicFormView::AssertValid();
}

void CFormWkiMetodos::Dump(CDumpContext& dc) const
{
	cdxCDynamicFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFormWkiMetodos message handlers

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiMetodos::SetWorkitem(CDefWorkitem* p_objWorkitem) {
	m_objDefWki = p_objWorkitem;
}

//////////////////////////////////////////////////////////////////////
// 
BOOL CFormWkiMetodos::OnDataUpdate(CViewCommand* p_Command) {
	switch(p_Command->GetCommandType()) {
		case COMMAND_UPDATE_ALL:
			/*m_lstDevices.DeleteAllItems();
			m_treeGrupos.DeleteAllItems();
			LlenarListaDevices();
			LlenarListaGrupos();*/
		break;

		case COMMAND_UPDATE_DEFWORKITEM: {
			SetWorkitem((CDefWorkitem*)p_Command->GetData());
			LlenarListaMetodos();
			if(m_lstMetodos.GetItemCount()) {
				m_lstMetodos.SetItemState(0, LVIS_SELECTED, LVIS_SELECTED);
				RefreshMetodo();
			}
			else {
				m_ctrlCodigo.SetText("");
				m_ctrlCodigo.EmptyUndoBuffer();
			}
		break;}
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiMetodos::OnInitialUpdate() {
	cdxCDynamicFormView::OnInitialUpdate();
	
	AddSzOleControl(&m_ctrlCodigo, mdResize, mdResize, false);
	m_ctrlCodigo.BringWindowToTop();
	m_lstMetodos.Init();

	CScintillaWrapper objWrap(&m_ctrlCodigo);
	objWrap.Init("CFormWkiMetodos");
	m_frameMetodos.SetIcon(IDI_ICON_CODIGO);
	m_btnAdd.SetIcon(IDI_ICON_ABM_ADD, (int)BTNST_AUTO_GRAY);
	m_btnRemove.SetIcon(IDI_ICON_ABM_REMOVE, (int)BTNST_AUTO_GRAY);
	m_btnAdd.SetTooltipText("Add Method");
	m_btnRemove.SetTooltipText("Remove Method");
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiMetodos::LlenarListaMetodos() {
	m_lstMetodos.DeleteAllItems();
	
	CMyMapIterador<CMetodo*>* iterador =  m_objDefWki->GetMetodos();
	if(iterador->begin()) {
		while(*iterador) {
			m_lstMetodos.Add((*iterador)++, false);
		}
	}
	delete iterador;
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiMetodos::RefreshMetodo() {
	CMetodo* oMet;

	m_lstMetodos.GetSelected(&oMet);
	if(!oMet) return;
	m_ctrlCodigo.SetText(oMet->GetCodigo());
	m_ctrlCodigo.EmptyUndoBuffer();
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiMetodos::OnButtonAddMetodo() {
	CInputBox objInpBox(m_hWnd);

	if(!objInpBox.DoModal("Add Method", "Enter the method name")) {
		return;
	}
	CMetodo* oMetodo = new CMetodo;
	oMetodo->SetNombre(objInpBox.Text);
	m_objDefWki->AddMetodo(oMetodo);
	m_lstMetodos.Add(oMetodo, true);
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiMetodos::OnButtonRemoveMetodo() {
	CMetodo* oMet;
	int nSel = m_lstMetodos.GetSelected(&oMet);
	if(nSel == -1) {
		return;
	}
	m_objDefWki->RemoveMetodo(oMet);
	m_lstMetodos.DeleteItem(nSel);
	if(m_lstMetodos.GetItemCount()) {
		m_lstMetodos.SelectNext(-1, nSel);
		RefreshMetodo();
	}
	else {
		m_ctrlCodigo.SetText("");
		m_ctrlCodigo.EmptyUndoBuffer();
	}
}

//////////////////////////////////////////////////////////////////////
// 
void CFormWkiMetodos::OnItemChanged(NMHDR* pNMHDR, LRESULT* pResult) {
	LPNMLISTVIEW pData = (LPNMLISTVIEW)pNMHDR;

	if(pData->uChanged == LVIF_STATE && pData->uOldState & LVIS_SELECTED) {
		// Cuando un mtodo pierde el foco, le seteo el cdigo
		CMetodo* oMet = (CMetodo*)m_lstMetodos.GetItemData(pData->iItem);
		if(oMet) {
			oMet->SetCodigo(m_ctrlCodigo.GetText());
		}
	}
	if(pData->uChanged == LVIF_STATE && pData->uNewState & LVIS_SELECTED) {
		RefreshMetodo();
	}
	
	*pResult = 0;
}

//////////////////////////////////////////////////////////////////////
// Actualiza los datos editados al workitem
bool CFormWkiMetodos::UpdateWorkitem() {
	// Solo tengo que actualizar el cdigo del mtodo en el que estoy parado
	CMetodo* oMet;
	m_lstMetodos.GetSelected(&oMet);
	if(oMet) {
		oMet->SetCodigo(m_ctrlCodigo.GetText());
	}
	return true;
}

/////////////////////////////////////////////////////////////////////////////
// Redefinido porque el framework me habilita todos los controles, sin importar
// lo que uno especifique inicialmente
void CFormWkiMetodos::OnEnable(BOOL bEnable) {
	cdxCDynamicFormView::OnEnable(bEnable);
}