#include "stdafx.h"
#include "CompIntDesigner.h"

#include "MainFrm.h"

#include "rolesview.h"
#include "RolesWkitemsTree.h"
#include "FormWkiMetodos.h"
#include "FormWkiEventosMW.h"
#include "FormWkiEventoMW.h"
#include "FormWkiInfo.h"
#include "AddFlowView.h"
#include "ViewReceiverBase.h"
#include "ViewCommand.h"
#include "CompIntDesignerDoc.h"
#include "CompIntDesignerView.h"
#include "TabWorkitem.h"
#include "DlgSettings.h"
#include "WorkitemView.h"
#include "Domain\ModelManager.h"
#include "Domain\Globales.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_COMMAND(ID_SETTINGS, OnClickSettings)
	ON_COMMAND(ID_SHOW_WKI_ROLES, OnShowWkiRoles)
	ON_COMMAND(ID_CONNECT_KBD, OnClickConnectKBD)
	ON_UPDATE_COMMAND_UI(ID_SHOW_WKI_ROLES, OnUpdateShowWkiRoles)
	ON_UPDATE_COMMAND_UI(ID_SHOW_WKI_ROLES, OnUpdateConnectKbd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame() {}

CMainFrame::~CMainFrame() {}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SetFullColorImage(24, 24, IDR_MAINFRAME, RGB(255, 0, 255));
	
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	m_wndToolBar.SetButtonStyle(0, TBBS_CHECKBOX);
	m_wndToolBar.SetButtonStyle(2, TBBS_CHECKBOX);

	m_bRolesShow = true;
	m_wndRoles = CreateNewChild(RUNTIME_CLASS(CRolesView), IDR_WORKITEMS, NULL, NULL);//m_hMDIMenu, m_hMDIAccel);
	m_wndRoles->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_USER), FALSE);

	m_bConnected = false;
	return 0;
}

//////////////////////////////////////////////////////////////////////////
///
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

/////////////////////////////////////////////////////////////////////////////
// 
void CMainFrame::AddWorkitemPane(CDefWorkitem* p_objWorkitem, stWkiRol* p_wkiRol) {
	CMDIChildWnd* wnd = CreateNewChild(RUNTIME_CLASS(CWorkitemView), IDR_WORKITEM, NULL, NULL);//m_hMDIMenu, m_hMDIAccel);
	wnd->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_PACKAGE), FALSE);
	m_lstVentanas.AddTail(wnd);

	CWorkitemView* wkiView = reinterpret_cast<CWorkitemView*>(wnd);
	wkiView->SetWkiData(p_objWorkitem, p_wkiRol);
}

/////////////////////////////////////////////////////////////////////////////
// 
void CMainFrame::OnDestroy() {
	CMDIFrameWnd::OnDestroy();
}

/////////////////////////////////////////////////////////////////////////////
// 
void CMainFrame::OnClickSettings() {
	CDlgSettings objDlg;
	objDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// 
void CMainFrame::OnWindowClosing(CMDIChildWnd* pWnd) {
	POSITION pos = m_lstVentanas.Find(pWnd);
	if(pos) {
		m_lstVentanas.RemoveAt(pos);
	}
	else if(pWnd == m_wndRoles) {
		m_wndRoles = NULL;
		m_bRolesShow = false;
	}
}

/////////////////////////////////////////////////////////////////////////////
// 
void CMainFrame::OnShowWkiRoles() {
	if(m_bRolesShow) {
		m_bRolesShow = false;
		m_wndRoles->ShowWindow(SW_HIDE);
		//m_wndRoles->SendMessage(WM_CLOSE);
	}
	else {
		m_bRolesShow = true;
		if(m_wndRoles) {
			m_wndRoles->ShowWindow(SW_SHOW);
		}
		else {
			m_wndRoles = CreateNewChild(RUNTIME_CLASS(CRolesView), IDR_WORKITEMS, NULL, NULL);//m_hMDIMenu, m_hMDIAccel);
			m_wndRoles->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_USER), FALSE);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// 
void CMainFrame::OnClickConnectKBD() {
	if(m_bConnected) {
		m_bConnected = false;
		return;
	}
	while(true) {
		if(!g_objModelManager->LoadRoles()) {
			// La config de la BD esta mal
			CDlgSettings objSettings;
			if(objSettings.DoModal() == IDCANCEL) {
				m_bConnected = false;
				break;
			}
		}
		else {
			if(m_wndRoles) {
				CViewCommand pComm(COMMAND_UPDATE_ROLES);
				((CRolesView*)m_wndRoles)->OnDataUpdate(&pComm);
			}
			m_bConnected = true;
			break;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// 
void CMainFrame::OnUpdateShowWkiRoles(CCmdUI* pCmdUI) {
	pCmdUI->SetCheck(m_bRolesShow);
}

/////////////////////////////////////////////////////////////////////////////
// 
void CMainFrame::OnUpdateConnectKbd(CCmdUI* pCmdUI) {
	pCmdUI->SetCheck(m_bConnected);
}