#include "stdafx.h"
#include "compintdesigner.h"
#include "MetodosListCtrl.h"
#include "Domain\Metodo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNAMIC(CMetodosListCtrl, CMyListCtrl)

CMetodosListCtrl::CMetodosListCtrl() {
	m_oldSortAscending = false;
	m_bCustomDraw = true;
}

CMetodosListCtrl::~CMetodosListCtrl() {

}

BEGIN_MESSAGE_MAP(CMetodosListCtrl, CMyListCtrl) 
   ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick) 
   ON_NOTIFY_REFLECT(NM_DBLCLK, OnNMLdblclk)
   ON_WM_CONTEXTMENU()
END_MESSAGE_MAP()


//////////////////////////////////////////////////////////////////////
// 
bool CMetodosListCtrl::Init() {
	CRect rect;

	SetExtendedStyle(LVS_EX_FULLROWSELECT);
	ModifyStyle(NULL, LVS_SHOWSELALWAYS);

	GetClientRect(&rect);
	InsertColumn(0, _T(""), LVCFMT_CENTER, rect.Width());

	return true;
}

//////////////////////////////////////////////////////////////////////
// 
void CMetodosListCtrl::OnColumnClick(NMHDR *pNMHDR, LRESULT *pResult) {
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR; 

	if(!GetItemCount()) return;
	// Item is column clicked
	int sortItem = pNMListView->iSubItem;
	// Sort table
	m_oldSortAscending = !m_oldSortAscending;
	SetSortArrow(sortItem, m_oldSortAscending);
	SortItems(SortProc, sortItem + (m_oldSortAscending ? 0:100));
	this->Invalidate();
	*pResult = 0; 
} 

//////////////////////////////////////////////////////////////////////
// 
int CMetodosListCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort){ 
	CMetodo* metodo1 = (CMetodo*)lParam1; 
	CMetodo* metodo2 = (CMetodo*)lParam2; 
	if((metodo1 == NULL) || (metodo2 == NULL)) {
		return 0;
	}
	
	switch(lParamSort) {
		case 0:	// Sort ascendente
			return _tcsicmp(metodo1->GetNombre(), metodo2->GetNombre());
		break;

		case 100:	// Sort descendente
			return _tcsicmp(metodo2->GetNombre(), metodo1->GetNombre());
		break;
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////
// 
void CMetodosListCtrl::OnContextMenu(CWnd* pWnd, CPoint point) {
//   POINT point; 
//   ::GetCursorPos(&point); 

	// tecxx 0609 2002 
	// fix - on right click, we also want to change the current selection like the left click does 
	CPoint p = point;
	ScreenToClient(&p);
	int it = HitTest(p);
	if(it != -1) {
      SetSelectionMark(it);   // display selection mark correctly! 
	}
	// fix end 

	/*// Create up-to-date popupmenu
	UINT flags,flagSSL1,flagSSL2;
	CTitleMenu m_ServerMenu;
	CMenu m_ServerPrioMenu;

	CServer* test=NULL;
	if (this->GetSelectionMark() != -1) test=(CServer*)GetItemData(GetSelectionMark());

	// set state of selection-dependent menuitems
	flags=MF_STRING || MF_DISABLED;
	if (this->GetSelectionMark() != -1) if (test != NULL) flags=MF_STRING;
	flagSSL1=MF_STRING || MF_DISABLED;
	flagSSL2=MF_STRING || MF_DISABLED;

	if (test != NULL) 
		if (test->IsStaticMember()) flagSSL2=MF_STRING; else flagSSL1=MF_STRING;

	// add priority switcher
	m_ServerPrioMenu.CreateMenu();
	m_ServerPrioMenu.AppendMenu(MF_STRING,MP_PRIOLOW,GetResString(IDS_PRIOLOW));
	m_ServerPrioMenu.AppendMenu(MF_STRING,MP_PRIONORMAL,GetResString(IDS_PRIONORMAL));
	m_ServerPrioMenu.AppendMenu(MF_STRING,MP_PRIOHIGH,GetResString(IDS_PRIOHIGH));

	m_ServerMenu.CreatePopupMenu(); 
	m_ServerMenu.AddMenuTitle(GetResString(IDS_EM_SERVER));
	m_ServerMenu.AppendMenu(flags,MP_CONNECTTO, GetResString(IDS_CONNECTTHIS)); 
	m_ServerMenu.AppendMenu(flags|MF_POPUP,(UINT_PTR)m_ServerPrioMenu.m_hMenu, GetResString(IDS_PRIORITY));

	m_ServerMenu.AppendMenu( flagSSL1,MP_ADDTOSTATIC, GetResString(IDS_ADDTOSTATIC));
	m_ServerMenu.AppendMenu( flagSSL2,MP_REMOVEFROMSTATIC, GetResString(IDS_REMOVEFROMSTATIC));

	m_ServerMenu.AppendMenu(MF_STRING|MF_SEPARATOR);	
	m_ServerMenu.AppendMenu(flags,MP_REMOVE,   GetResString(IDS_REMOVETHIS)); 
	m_ServerMenu.AppendMenu(MF_STRING,MP_REMOVEALL, GetResString(IDS_REMOVEALL));
	m_ServerMenu.AppendMenu(MF_SEPARATOR); 
	m_ServerMenu.AppendMenu(MF_STRING,MP_GETED2KLINK, GetResString(IDS_DL_LINK1) );
//   m_ServerMenu.AppendMenu(MF_STRING,Irc_SetSendLink,GetResString(IDS_IRC_ADDLINKTOIRC)); 

	m_ServerMenu.SetDefaultItem(MP_CONNECTTO);
	m_ServerMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this); 

	VERIFY( m_ServerPrioMenu.DestroyMenu() );
	VERIFY( m_ServerMenu.DestroyMenu() );*/
}

//////////////////////////////////////////////////////////////////////
// 
void CMetodosListCtrl::OnNMLdblclk(NMHDR *pNMHDR, LRESULT *pResult){ // mod bb 27.09.02
	if(GetSelectionMark() != (-1)) {
		//theApp.serverconnect->ConnectToServer((CServer*)GetItemData(GetSelectionMark())); 
	   //theApp.emuledlg->ShowConnectionState(false);
	}
}

//////////////////////////////////////////////////////////////////////
// 
int CMetodosListCtrl::GetSelected(CMetodo** p_oMet) { 
	int nSel = GetNextItem(-1, LVNI_SELECTED);
	if(nSel == -1) {
		*p_oMet = NULL;
		return nSel;
	}
	*p_oMet = (CMetodo*)GetItemData(nSel);
	return nSel;
}

//////////////////////////////////////////////////////////////////////
// 
int CMetodosListCtrl::Add(CMetodo* oMet, bool bSelect) {
	int iItem = InsertItem(0, oMet->GetNombre());
	SetItemData(iItem, (DWORD)oMet);
	if(bSelect) {
		SetItemState(iItem, LVIS_SELECTED, LVIS_SELECTED);
	}
	return iItem;
}

/*//////////////////////////////////////////////////////////////////////
// 
bool CMetodosListCtrl::Remove(CMetodo* oMet) {
	return true;
}*/
