#include "stdafx.h"
#include "CompIntDesigner.h"
#include "RolesWkitemsTree.h"

#include "Domain\Globales.h"
#include "Domain\ModelManager.h"
#include <MyMap.h>
#include "Domain\Rol.h"
#include "Domain\DefWorkitem.h"
#include "ViewCommand.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRolesWkitemsTree

IMPLEMENT_DYNCREATE(CRolesWkitemsTree, CTreeView)

CRolesWkitemsTree::CRolesWkitemsTree() {
	m_bCreated = false;
}

CRolesWkitemsTree::~CRolesWkitemsTree() {
}

BEGIN_MESSAGE_MAP(CRolesWkitemsTree, CTreeView)
	//{{AFX_MSG_MAP(CRolesWkitemsTree)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRolesWkitemsTree message handlers
void CRolesWkitemsTree::OnInitialUpdate() {
	if(m_bCreated) {
		return;
	}
	CTreeView::OnInitialUpdate();

	m_imageList.Create(16, 16, ILC_COLOR32, 1, 0);
	m_imageList.Add((HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ICON_USER), IMAGE_ICON, 16, 16, LR_LOADTRANSPARENT));
	m_imageList.Add((HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ICON_USER), IMAGE_ICON, 16, 16, LR_LOADTRANSPARENT));
	m_imageList.Add((HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ICON_PACKAGE), IMAGE_ICON, 16, 16, LR_LOADTRANSPARENT));
	m_imageList.Add((HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ICON_PACKAGE1), IMAGE_ICON, 16, 16, LR_LOADTRANSPARENT));
	m_imageList.Add((HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ICON_PACKAGE_REDEFINED), IMAGE_ICON, 16, 16, LR_LOADTRANSPARENT));
	m_imageList.Add((HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ICON_PACKAGE_TEMPLATE), IMAGE_ICON, 16, 16, LR_LOADTRANSPARENT));

	CTreeCtrl& treeControl = GetTreeCtrl();
	treeControl.SetImageList(&m_imageList, TVSIL_NORMAL);
	DWORD dwVal = GetWindowLong(treeControl.GetSafeHwnd(), GWL_STYLE);
	SetWindowLong(treeControl.GetSafeHwnd(), GWL_STYLE, dwVal | TVS_HASBUTTONS | TVS_HASLINES | TVS_LINESATROOT);
	LlenarArbolRoles();
	m_bCreated = true;
}

/////////////////////////////////////////////////////////////////////////////
// 
void CRolesWkitemsTree::LlenarArbolRoles() {
	CMyMapIterador<CRol*>* mapaRoles;

	CTreeCtrl& treeControl = GetTreeCtrl();
	mapaRoles = g_objModelManager->GetRoles();

	if(!mapaRoles->begin()) {
		delete mapaRoles;
		return;
	}
	while(*mapaRoles) {
		CRol* objRol = (*mapaRoles)++;
		
		TVINSERTSTRUCT insStruct;
		insStruct.hParent = TVI_ROOT;
		insStruct.hInsertAfter = TVI_LAST;
		insStruct.item.iImage = 0;
		insStruct.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_PARAM;// | TVIS_STATEIMAGEMASK;
		insStruct.item.pszText = (LPTSTR)(LPCTSTR)objRol->GetID();
		insStruct.item.state = 2;
		insStruct.item.stateMask = 0;

		HTREEITEM h =  treeControl.InsertItem(&insStruct);
		treeControl.SetItemData(h, (DWORD)objRol);
		treeControl.SetItemImage(h, 0,1);
		CMyMapIterador<stWkiRol*>* mapaWkis = objRol->GetWorkitems();
		if(mapaWkis->begin()) {
			while(*mapaWkis) {
				stWkiRol* stWki = (*mapaWkis)++;
				// Inserto en el tree
				TVINSERTSTRUCT insStructHijo;
				insStructHijo.hParent = h;
				insStructHijo.hInsertAfter = TVI_LAST;
				insStructHijo.item.iImage = 2;
				insStructHijo.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_PARAM;// | TVIS_STATEIMAGEMASK;
				insStructHijo.item.pszText = (LPTSTR)(LPCTSTR)stWki->m_strWkiID;
				insStructHijo.item.state = 0;
				insStructHijo.item.stateMask = 0;
				HTREEITEM hItem = treeControl.InsertItem(&insStructHijo);
				treeControl.SetItemData(hItem, (DWORD)stWki);
				treeControl.SetItemImage(hItem, 5, 5);
			}
		}
		delete mapaWkis;
	}
	delete mapaRoles;
}

//////////////////////////////////////////////////////////////////////
// 
BOOL CRolesWkitemsTree::OnDataUpdate(CViewCommand* p_Command) {
	switch(p_Command->GetCommandType()) {
		case COMMAND_UPDATE_ALL: {
			CTreeCtrl& treeControl = GetTreeCtrl();
			treeControl.DeleteAllItems();
			LlenarArbolRoles();
		break;}

		case COMMAND_WORKITEM_APPLY_CHANGES: {
			CTreeCtrl& treeControl = GetTreeCtrl();
			stWkiRol* stWki = (stWkiRol*)p_Command->GetData();
			HTREEITEM hItem = FindItemByUserData((DWORD)stWki);
			if(hItem) {
				treeControl.EnsureVisible(hItem);
				treeControl.SetItemImage(hItem, 5,5);
			}
		break;}
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
HTREEITEM CRolesWkitemsTree::FindItemByUserData(DWORD p_dwValue) {
	CTreeCtrl& treeControl = GetTreeCtrl();
	HTREEITEM hRoot = treeControl.GetRootItem();
	while(hRoot != NULL) {
		HTREEITEM hChild = treeControl.GetChildItem(hRoot);
		while(hChild != NULL) {
			if(treeControl.GetItemData(hChild) == p_dwValue) {
				return hChild;
			}
			hChild = treeControl.GetNextSiblingItem(hChild);
		}
		hRoot = treeControl.GetNextSiblingItem(hRoot);
	}
	return NULL;
}

//////////////////////////////////////////////////////////////////////////
/// Tengo que postear el mensaje hacia arriba (no s porque no llega reflejado?)
void CRolesWkitemsTree::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult) {
	GetParent()->PostMessage(WM_LBUTTONDBLCLK, 0, 0);
	*pResult = 0;
}
