#include "stdafx.h"
#include "compintdesigner.h"
#include "TActionsListCtrl.h"
#include "Domain\TimedAction.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define MLC_DT_TEXT (DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER | DT_END_ELLIPSIS)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNAMIC(CTActionsListCtrl, CMyListCtrl)

CTActionsListCtrl::CTActionsListCtrl() {
	m_oldSortAscending = false;
	m_bCustomDraw = false;	// si no sale de color gris
}

CTActionsListCtrl::~CTActionsListCtrl() {

}

BEGIN_MESSAGE_MAP(CTActionsListCtrl, CMyListCtrl) 
   ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick) 
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////////////
// 
bool CTActionsListCtrl::Init() {
	CRect rect;

	SetExtendedStyle(LVS_EX_FULLROWSELECT);
	ModifyStyle(NULL, LVS_SHOWSELALWAYS);

	GetClientRect(&rect);
	InsertColumn(0, _T(""), LVCFMT_CENTER, rect.Width());

	return true;
}

//////////////////////////////////////////////////////////////////////
// 
void CTActionsListCtrl::OnColumnClick(NMHDR *pNMHDR, LRESULT *pResult) {
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR; 

	if(!GetItemCount()) return;
	// Item is column clicked
	int sortItem = pNMListView->iSubItem;
	// Sort table
	m_oldSortAscending = !m_oldSortAscending;
	SetSortArrow(sortItem, m_oldSortAscending);
	SortItems(SortProc, sortItem + (m_oldSortAscending ? 0:100));
	this->Invalidate();
	*pResult = 0; 
}

//////////////////////////////////////////////////////////////////////
// 
int CTActionsListCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort){ 
	CTimedAction* item1 = (CTimedAction*)lParam1;
	CTimedAction* item2 = (CTimedAction*)lParam2;
	if((item1 == NULL) || (item2 == NULL)) {
		return 0;
	}
	
	switch(lParamSort) {
		case 0:	// Sort ascendente
			return _tcsicmp(item1->GetTime(), item2->GetTime());
		break;

		case 100:	// Sort descendente
			return _tcsicmp(item2->GetTime(), item1->GetTime());
		break;
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////
// 
int CTActionsListCtrl::GetSelected(CTimedAction** p_oTA) {
	int nSel = GetNextItem(-1, LVNI_SELECTED);
	if(nSel == -1) {
		*p_oTA = NULL;
		return nSel;
	}
	*p_oTA = (CTimedAction*)GetItemData(nSel);
	return nSel;
}

//////////////////////////////////////////////////////////////////////
// 
int CTActionsListCtrl::Add(CTimedAction* oTA, bool bSelect) {
	LPCTSTR strTime = oTA->GetTime();
	if(strTime[0] == 'I') {
		strTime = &strTime[1];
	}
	int iItem = InsertItem(0, strTime);
	SetItemData(iItem, (DWORD)oTA);
	if(bSelect) {
		SetItemState(iItem, LVIS_SELECTED, LVIS_SELECTED);
	}
	return iItem;
}
