#include "stdafx.h"
#include "compintdesigner.h"
#include "TabEstTActions.h"
#include "Domain\ScintillaWrapper.h"
#include "InputBox.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CTabEstTActions::CTabEstTActions(CWnd* pParent /*=NULL*/)
: CTabPageSSL (CTabEstTActions::IDD, pParent) {
	//{{AFX_DATA_INIT(CTabEstTActions)
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_objEst = NULL;
}

CTabEstTActions::~CTabEstTActions() {

}

void CTabEstTActions::DoDataExchange(CDataExchange* pDX) {
	CTabPageSSL::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabEstTActions)
		DDX_Control(pDX, IDC_SCINTILLACTRL2, m_ctrlCod);
		DDX_Control(pDX, IDC_BUTTON_TA_ADD, m_btnAdd);
		DDX_Control(pDX, IDC_BUTTON_TA_REMOVE, m_btnRemove);
		DDX_Control(pDX, IDC_LST_TACTIONS, m_lstActions);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTabEstTActions, CTabPageSSL)
	//{{AFX_MSG_MAP(CTabEstTActions)
		ON_BN_CLICKED(IDC_BUTTON_TA_ADD, OnClickButtonAdd)
		ON_BN_CLICKED(IDC_BUTTON_TA_REMOVE, OnClickButtonRemove)
		ON_NOTIFY(LVN_ITEMCHANGED, IDC_LST_TACTIONS, OnItemChanged)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DYNAMIC_MAP(CTabEstTActions, CTabPageSSL)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_PICTURE, mdRepos, mdNone)
	DYNAMIC_MAP_ENTRY(IDC_LST_TACTIONS, mdNone, mdResize)

	DYNAMIC_MAP_ENTRY(IDC_BUTTON_TA_ADD, mdRepos, mdRepos)
	DYNAMIC_MAP_ENTRY(IDC_BUTTON_TA_REMOVE, mdRepos, mdRepos)
END_DYNAMIC_MAP()

//////////////////////////////////////////////////////////////////////
// 
BOOL CTabEstTActions::OnInitDialog() {
	CTabPageSSL::OnInitDialog();

	AddSzOleControl(&m_ctrlCod, mdResize, mdResize, false);
	CScintillaWrapper objWrap(&m_ctrlCod);
	objWrap.Init("CTabEstTActions");

	m_lstActions.Init();
	CMyMapIterador<CTimedAction*>* iterador = m_objEst->GetTimedActions();
	if(iterador->begin()) {
		while(*iterador) {
			m_lstActions.Add((*iterador)++, false);
		}
	}
	delete iterador;

	m_btnAdd.SetIcon(IDI_ICON_ABM_ADD, (int)BTNST_AUTO_GRAY);
	m_btnRemove.SetIcon(IDI_ICON_ABM_REMOVE, (int)BTNST_AUTO_GRAY);
	m_btnAdd.SetTooltipText("Add Timed Action");
	m_btnRemove.SetTooltipText("Remove Timed Action");
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
void CTabEstTActions::OnClickButtonAdd() {
	CInputBox objInpBox(m_hWnd);

	if(!objInpBox.DoModal("Add Timed Action", "Enter the action time or expression to evaluate")) {
		return;
	}
	LPCTSTR strData = objInpBox.Text;
	if(lstrlen(strData) == 0) {
		return;
	}
	CTimedAction* oTa = new CTimedAction;
	// Si no ingresaron un nmero, es una expresin lua para evaluar
	if(!isdigit(strData[0])) {
		oTa->SetTimeNeedsEval();
	}	
	oTa->SetTime(strData);
	m_objEst->AddTimedAction(oTa);
	m_lstActions.Add(oTa, true);
}

//////////////////////////////////////////////////////////////////////
// 
void CTabEstTActions::OnClickButtonRemove() {
	CTimedAction* oTAct;

	int iSel = m_lstActions.GetSelected(&oTAct);
	if(iSel == -1) {
		return;
	}
	m_objEst->RemoveTimedAction(oTAct);
	m_lstActions.DeleteItem(iSel);
	if(m_lstActions.GetItemCount()) {
		m_lstActions.SelectNext(-1, iSel);
		RefreshAction();
	}
	else {
		m_ctrlCod.SetText("");
		m_ctrlCod.EmptyUndoBuffer();
	}
}

//////////////////////////////////////////////////////////////////////
// 
void CTabEstTActions::OnItemChanged(NMHDR* pNMHDR, LRESULT* pResult) {
	LPNMLISTVIEW pData = (LPNMLISTVIEW)pNMHDR;

	if(pData->uChanged == LVIF_STATE && pData->uOldState & LVIS_SELECTED) {
		// Cuando un mtodo pierde el foco, le seteo el cdigo
		CTimedAction* oTA = (CTimedAction*)m_lstActions.GetItemData(pData->iItem);
		if(oTA) {
			oTA->SetCodigo(m_ctrlCod.GetText());
		}
	}
	if(pData->uChanged == LVIF_STATE && pData->uNewState & LVIS_SELECTED) {
		RefreshAction();
	}
	
	*pResult = 0;
}

//////////////////////////////////////////////////////////////////////
// 
void CTabEstTActions::RefreshAction() {
	CTimedAction* oTA;

	m_lstActions.GetSelected(&oTA);
	if(!oTA) return;
	m_ctrlCod.SetText(oTA->GetCodigo());
	m_ctrlCod.EmptyUndoBuffer();
}

//////////////////////////////////////////////////////////////////////
// Actualiza la info del estado con lo que se haya ingresado
void CTabEstTActions::UpdateEstado() {
	// Siempre que una accion pierde el foco se actualiza su codigo
	// as que solo actualizar el codigo de la que esta seleccionada ahora
	CTimedAction* objTA;
	m_lstActions.GetSelected(&objTA);
	if(objTA) {
		objTA->SetCodigo(m_ctrlCod.GetText());
	}
}