#include "stdafx.h"
#include "compintdesigner.h"
#include "TabTranAct.h"
#include "Domain\ScintillaWrapper.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CTabTranAct::CTabTranAct(CWnd* pParent /*=NULL*/)
: CTabPageSSL (CTabTranAct::IDD, pParent) {
	//{{AFX_DATA_INIT(CTabTranAct)
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_objTran = NULL;
}

CTabTranAct::~CTabTranAct() {

}

void CTabTranAct::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabTranAct)
		DDX_Control(pDX, IDC_SCINTILLACTRL2, m_ctrlAct);
		DDX_Control(pDX, IDC_CHECK_DEFAULT_ACTION, m_chkDefaultAction);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTabTranAct, CTabPageSSL)
	//{{AFX_MSG_MAP(CTabTranAct)
		ON_BN_CLICKED(IDC_CHECK_DEFAULT_ACTION, OnClickDefaultAction)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DYNAMIC_MAP(CTabTranAct, CTabPageSSL)
	DYNAMIC_MAP_ENTRY(IDC_STATIC_PICTURE, mdRepos, mdNone)
END_DYNAMIC_MAP()

//////////////////////////////////////////////////////////////////////
// 
BOOL CTabTranAct::OnInitDialog() {
	CTabPageSSL::OnInitDialog();

	AddSzOleControl(&m_ctrlAct, mdResize, mdResize, false);
	CScintillaWrapper objWrap(&m_ctrlAct);
	objWrap.Init("CTabTranAct");

	switch(m_objTran->GetTipoAccion()) {
		case SIN_ACCION:
			m_chkDefaultAction.SetCheck(BST_UNCHECKED);
			m_ctrlAct.SetText("");
		break;

		case DEFAULT:
			m_chkDefaultAction.SetCheck(BST_CHECKED);
			m_ctrlAct.SetText("");
		break;

		case CUSTOM:
			m_chkDefaultAction.SetCheck(BST_UNCHECKED);
			m_ctrlAct.SetText(m_objTran->GetAccion());
		break;
	}
	m_ctrlAct.EmptyUndoBuffer();
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
void CTabTranAct::UpdateTransicion() {
	if(m_chkDefaultAction.GetCheck() == BST_CHECKED) {
		m_objTran->SetTipoAccion(DEFAULT);
		m_objTran->SetAccion("");
	}
	else {
		CString strCode;
		strCode = m_ctrlAct.GetText();
		strCode.TrimLeft();
		strCode.TrimRight();
		if(strCode.GetLength() != 0) {
			m_objTran->SetTipoAccion(CUSTOM);
			m_objTran->SetAccion(m_ctrlAct.GetText());
		}
		else {
			m_objTran->SetTipoAccion(SIN_ACCION);
			m_objTran->SetAccion("");
		}
	}
}


//////////////////////////////////////////////////////////////////////
// 
void CTabTranAct::OnClickDefaultAction() {
	if(m_chkDefaultAction.GetCheck() == BST_CHECKED) {
		::EnableWindow(m_ctrlAct.m_hWnd, FALSE);
	}
	else {
		::EnableWindow(m_ctrlAct.m_hWnd, TRUE);
	}
}