#include "stdafx.h"
#include "compintdesigner.h"
#include "CompIntDesignerDoc.h"
#include "CompIntDesignerView.h"
#include "WorkitemView.h"
#include "MainFrm.h"
#include "Domain\ModelManager.h"
#include "Domain\Globales.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWorkitemView

IMPLEMENT_DYNCREATE(CWorkitemView, CMDIChildWnd)

CWorkitemView::CWorkitemView() {
	m_bOnCloseApply = false;
}

CWorkitemView::~CWorkitemView() {}


BEGIN_MESSAGE_MAP(CWorkitemView, CMDIChildWnd)
	//{{AFX_MSG_MAP(CWorkitemView)
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	ON_COMMAND(ID_WKI_OPEN_MODEL, OnClickOpenXML)
	ON_COMMAND(ID_WKI_SAVE_MODEL, OnClickSaveXML)
	ON_COMMAND(ID_WKI_SAVE_SQL, OnClickSaveSQL)
	ON_COMMAND(ID_WKI_APPLY_CHANGES, OnClickApplyChanges)
	ON_COMMAND(ID_WKI_CANCEL_CHANGES, OnClickCancelChanges)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWorkitemView message handlers

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CWorkitemView::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) {
	TVisualObject *pTab = new TVisualObject(1, "Test", pContext, RUNTIME_CLASS(CTabWorkitem), TVisualObject::TOS_TABBOTTOM);
	TVisualObject *pTabView1 = new TVisualObject(2, "Details", pContext, RUNTIME_CLASS(CFormWkiInfo));
	TVisualObject *pTabView2 = new TVisualObject(3, "Methods", pContext, RUNTIME_CLASS(CFormWkiMetodos));
	TVisualObject *pTabView3 = new TVisualObject(4, "Middleware Events", pContext, RUNTIME_CLASS(CFormWkiEventosMW));
	TVisualObject *pTabView4 = new TVisualObject(5, "Transitions", pContext, RUNTIME_CLASS(CAddFlowView));

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		/*| CBRS_GRIPPER */| CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_WORKITEM))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SetFullColorImage(24, 24, IDR_WORKITEM, RGB(255, 0, 255));
	m_wndToolBar.EnableToolTips();

	m_Framework.Add(pTab);
	
	m_Framework.Add(pTab, pTabView1);
	m_Framework.Add(pTab, pTabView2);
	m_Framework.Add(pTab, pTabView3);
	m_Framework.Add(pTab, pTabView4);

	pTabView1->SetIcon(IDI_ICON_PACKAGE);
	pTabView2->SetIcon(IDI_ICON_CODIGO);
	pTabView3->SetIcon(IDI_ICON_SOBRE);
	pTabView4->SetIcon(IDI_ICON_FLOWCHART);

	m_Framework.Create(this);
	m_pTabs = pTab;
	m_pContext = pContext;

	m_frmInfo = (CFormWkiInfo*)pTabView1->GetWnd();
	m_frmTabWorkitem = (CTabWorkitem*)pTab->GetWnd();
	m_frmMetodos = (CFormWkiMetodos*)pTabView2->GetWnd();
	m_frmEventos = (CFormWkiEventosMW*)pTabView3->GetWnd();
	m_frmAddFlow = (CAddFlowView*)pTabView4->GetWnd();

	EnableToolTips();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
BOOL CWorkitemView::OnDataUpdate(CViewCommand* p_Command) {
	switch(p_Command->GetCommandType()) {
		case COMMAND_UPDATE_DEFWORKITEM: {
			SetWorkitem((CDefWorkitem*)p_Command->GetData());
			m_frmInfo->OnDataUpdate(p_Command);
			m_frmMetodos->OnDataUpdate(p_Command);
			m_frmEventos->OnDataUpdate(p_Command);
			m_frmAddFlow->OnDataUpdate(p_Command);
			SetWindowText(m_objDefWki->GetTipo());
			SetTitle(m_objDefWki->GetTipo());
		break;}
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
void CWorkitemView::SetWkiData(CDefWorkitem* p_objWorkitem, stWkiRol* p_objWkiRol) {
	SetWorkitem(p_objWorkitem);
	SetWkiRol(p_objWkiRol);
	CViewCommand pComm(COMMAND_UPDATE_DEFWORKITEM);
	pComm.SetData(p_objWorkitem);
	m_frmInfo->OnDataUpdate(&pComm);
	m_frmMetodos->OnDataUpdate(&pComm);
	m_frmEventos->OnDataUpdate(&pComm);
	m_frmAddFlow->OnDataUpdate(&pComm);

	CString strTitle = m_objDefWki->GetTipo();
	strTitle += " - Template";
	SetWindowText(strTitle);
	SetTitle(strTitle);
}

//////////////////////////////////////////////////////////////////////
// 
void CWorkitemView::SetWorkitem(CDefWorkitem* p_objWorkitem) {
	m_objDefWki = p_objWorkitem;
}

//////////////////////////////////////////////////////////////////////
// 
void CWorkitemView::SetWkiRol(stWkiRol* p_objRol) {
	m_objRol = p_objRol;
}

/////////////////////////////////////////////////////////////////////////////
// 
void CWorkitemView::AddMWEventPane(LPCTSTR p_strName, void* p_oEvt) {
	CCreateContext* pContext = new CCreateContext;
	pContext->m_pCurrentDoc = GetActiveDocument();
	pContext->m_pCurrentFrame = NULL;
	pContext->m_pLastView = this->GetActiveView();
	pContext->m_pNewDocTemplate = NULL;
	pContext->m_pNewViewClass = RUNTIME_CLASS(CCompIntDesignerView);
	TVisualObject* pTabView1 = new TVisualObject(m_Framework.GetCount() + 1, p_strName, pContext, RUNTIME_CLASS(CFormWkiEventoMW));

	pTabView1->SetIcon(IDI_ICON_SOBRE);
	pTabView1->EnableClose(TRUE);
	m_Framework.AddDynamic(m_pTabs, pTabView1);
	m_Framework.SetActivePane(pTabView1);

#pragma message("TODO: EMPROLIJAR ESTO!!: El resize a manopla que hago => " __FILE__)
	// Esto es para simular un resize, sino el tab sale mal 
	CRect rc; 
	m_frmTabWorkitem->GetClientRect(&rc);
	m_frmTabWorkitem->SendMessage(WM_SIZE, 0, MAKELONG(rc.Width(), rc.Height()));

	// Mandarle un WM_INITIALUPDATE a pedal (no estar faltando algo ms?)
	pTabView1->GetWnd()->SendMessage(WM_INITIALUPDATE, 0, 0);

	// Mandar el update
	CViewCommand pComm(COMMAND_UPDATE_EVT_MW);
	pComm.SetData(p_oEvt);
	((CFormWkiEventoMW*)(pTabView1->GetWnd()))->OnDataUpdate(&pComm);

	m_lstEventos.AddTail((CFormWkiEventoMW*)(pTabView1->GetWnd()));

	delete pContext;
}

//////////////////////////////////////////////////////////////////////
// 
void CWorkitemView::OnMWEventPaneClosing(CFormWkiEventoMW* p_oForm) {
	POSITION pos;
	pos = m_lstEventos.Find(p_oForm);
	if(pos) {
		m_lstEventos.RemoveAt(pos);
	}
}

//////////////////////////////////////////////////////////////////////
// 
void CWorkitemView::OnDestroy() {
	CMDIChildWnd::OnDestroy();
	m_Framework.Destroy();
}

//////////////////////////////////////////////////////////////////////
// 
void CWorkitemView::OnClose()  {
	if(!m_bOnCloseApply) {
		// Estoy cerrando cancelando los cambios
		CViewCommand pComm(COMMAND_WORKITEM_CANCEL_CHANGES);
		pComm.SetData(m_objRol);
		g_objViewManager->UpdateViews(this, &pComm);
		DELETE_NOT_NULL(m_objDefWki);
	}
	((CMainFrame*)GetParentFrame())->OnWindowClosing(this);
	CMDIChildWnd::OnClose();
}

//////////////////////////////////////////////////////////////////////
// Carga el modelo desde un archivo XML
void CWorkitemView::OnClickOpenXML() {
	CFileDialog dlgOpen(TRUE, _T("xml"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("Designer Model Files (*.xml)|*.xml||"), NULL);

	if(dlgOpen.DoModal() != IDOK) {
		return;
	}
	CDefWorkitem* objWki;
	CWaitCursor waitCursor;
	if(!g_objModelManager->LoadFromXML(dlgOpen.GetPathName(), &objWki)) {
		CString strTemp;
		strTemp.Format(IDS_ERROR_READING_FILE, dlgOpen.GetPathName());
		AfxMessageBox(strTemp, MB_ICONERROR);
		DELETE_NOT_NULL(objWki);
		return;
	}
	if(lstrcmpi(objWki->GetTipo(), m_objDefWki->GetTipo()) != 0) {
		CString strTemp;
		strTemp.Format(IDS_ERROR_FILE_WORKITEM_MISMATCH, objWki->GetTipo());
		AfxMessageBox(strTemp, MB_ICONERROR);
		DELETE_NOT_NULL(objWki);
		return;
	}
	// A la mierda con el otro workitem
	DELETE_NOT_NULL(m_objDefWki);
	SetWkiData(objWki, m_objRol);
}

//////////////////////////////////////////////////////////////////////
// Graba el modelo en un archivo XML
void CWorkitemView::OnClickSaveXML() {
	if(!UpdateWorkitem()) {
		return;
	}
	CFileDialog dlgSave(FALSE, _T("xml"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("Designer Model Files (*.xml)|*.xml||"));
	
	if(dlgSave.DoModal() != IDOK) {
		return;
	}
	CWaitCursor waitCursor;
	if(!g_objModelManager->SaveIntoXML(dlgSave.GetPathName(), m_objDefWki)) {
		CString strTemp;
		strTemp.Format(IDS_ERROR_WRITING_FILE, dlgSave.GetPathName());
		AfxMessageBox(strTemp, MB_ICONERROR);
	}
}

//////////////////////////////////////////////////////////////////////
// Graba el modelo en un script SQL
void CWorkitemView::OnClickSaveSQL() {
	if(!UpdateWorkitem()) {
		return;
	}
	CFileDialog dlgSave(FALSE, _T("sql"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("SQL Script Files (*.sql)|*.sql||"));
	
	if(dlgSave.DoModal() != IDOK) {
		return;
	}
	CWaitCursor waitCursor;
	if(!g_objModelManager->SaveIntoSQL(dlgSave.GetPathName(), m_objDefWki->GetTipo(), m_objRol->m_strRolID, m_objDefWki)) {
		CString strTemp;
		strTemp.Format(IDS_ERROR_WRITING_FILE, dlgSave.GetPathName());
		AfxMessageBox(strTemp, MB_ICONERROR);
	}
}

//////////////////////////////////////////////////////////////////////
// Aplica los cambios y sale
void CWorkitemView::OnClickApplyChanges() {
	CWaitCursor waitCursor;
	if(!UpdateWorkitem()) {
		return;
	}
	if(!g_objModelManager->SaveIntoBD(m_objRol->m_strRolID, m_objDefWki)) {
		CString strTemp;
		strTemp.Format(IDS_ERROR_SAVING_BD, m_objDefWki->GetTipo());
		AfxMessageBox(strTemp, MB_ICONERROR);
		return;
	}
	CViewCommand pComm(COMMAND_WORKITEM_APPLY_CHANGES);
	pComm.SetData(m_objRol);
	g_objViewManager->UpdateViews(this, &pComm);
	DELETE_NOT_NULL(m_objDefWki);
	m_bOnCloseApply = true;
	SendMessage(WM_CLOSE);
}

//////////////////////////////////////////////////////////////////////
// Sale sin aplicar cambios
void CWorkitemView::OnClickCancelChanges() {
	m_bOnCloseApply = false;
	SendMessage(WM_CLOSE);
}

//////////////////////////////////////////////////////////////////////
// Actualiza los datos del workitem (para aplicar los cambios)
bool CWorkitemView::UpdateWorkitem() {
	if(m_lstEventos.GetCount() != 0) {
		POSITION pos = m_lstEventos.GetHeadPosition();
		while(pos) {
			CFormWkiEventoMW* objForm = m_lstEventos.GetAt(pos);
			if(objForm->CanClose()) {
				objForm->SendMessage(WM_CLOSE);	// Cuando se cierra se actualiza la info
				pos = m_lstEventos.GetHeadPosition();	// cuando se cierra se saca de la lista
			}
			else {
				int iIndex = m_frmTabWorkitem->GetTabIndex(objForm);
				m_frmTabWorkitem->SetActivePane(iIndex, TRUE);
				return false;
			}
		}
	}
	if(	m_frmInfo->UpdateWorkitem() &&
		m_frmMetodos->UpdateWorkitem() &&
		m_frmEventos->UpdateWorkitem() &&
		m_frmAddFlow->UpdateWorkitem())
	{
		return true;
	}
	else {
		AfxMessageBox("Error applying changes", MB_ICONERROR);
	}
	return false;
}
