#if !defined(AFX_WORKITEMVIEW_H__EF6CB09C_CF46_46D5_BD06_BD9BA2D2D955__INCLUDED_)
#define AFX_WORKITEMVIEW_H__EF6CB09C_CF46_46D5_BD06_BD9BA2D2D955__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// WorkitemView.h : header file
//

#include "ViewManager.h"
#include "ViewCommand.h"
#include "ViewReceiverBase.h"

#include "Domain\DefWorkitem.h"
#include "Domain\Rol.h"

#include "FormWkiMetodos.h"
#include "FormWkiEventosMW.h"
#include "FormWkiEventoMW.h"
#include "FormWkiInfo.h"
#include "AddFlowView.h"
#include "TabWorkitem.h"


/////////////////////////////////////////////////////////////////////////////
// CWorkitemView frame

class CWorkitemView : public CMDIChildWnd, public CViewReceiverBase
{
	DECLARE_DYNCREATE(CWorkitemView)
protected:
	CWorkitemView();           // protected constructor used by dynamic creation

// Attributes
public:
protected:
	CToolBar24    m_wndToolBar;
	TVisualFramework m_Framework;
	CCreateContext* m_pContext;
	TVisualObject* m_pTabs;

	CFormWkiInfo* m_frmInfo;
	CTabWorkitem* m_frmTabWorkitem;
	CFormWkiMetodos* m_frmMetodos;
	CFormWkiEventosMW* m_frmEventos;
	CList<CFormWkiEventoMW*, CFormWkiEventoMW*> m_lstEventos;
	CAddFlowView* m_frmAddFlow;

	CDefWorkitem* m_objDefWki;
	stWkiRol* m_objRol;

// Operations
public:
	void SetWkiData(CDefWorkitem*, stWkiRol*);
	BOOL OnDataUpdate(CViewCommand*);
	void SetWorkitem(CDefWorkitem* objWorkitem);
	void SetWkiRol(stWkiRol* objWkiRol);
	void AddMWEventPane(LPCTSTR strName, void* oEvt);
	void OnMWEventPaneClosing(CFormWkiEventoMW* oForm);

private:
	bool UpdateWorkitem();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWorkitemView)
	protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CWorkitemView();

	// Generated message map functions
	//{{AFX_MSG(CWorkitemView)
	afx_msg void OnDestroy();
	afx_msg void OnClose();
	afx_msg void OnClickOpenXML();
	afx_msg void OnClickSaveXML();
	afx_msg void OnClickSaveSQL();
	afx_msg void OnClickApplyChanges();
	afx_msg void OnClickCancelChanges();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	bool m_bOnCloseApply;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WORKITEMVIEW_H__EF6CB09C_CF46_46D5_BD06_BD9BA2D2D955__INCLUDED_)
