--------------------------
-- CONSTANTES SCINTILLA --
--------------------------
local SC_MARKNUM = {
	FOLDEREND = 25,
	FOLDEROPENMID = 26,
	FOLDERMIDTAIL = 27,
	FOLDERTAIL = 28,
	FOLDERSUB = 29,
	FOLDER = 30,
	FOLDEROPEN = 31,
}

local SC_MARK = {
	CIRCLE = 0,
	ROUNDRECT = 1,
	ARROW = 2,
	SMALLRECT = 3,
	SHORTARROW = 4,
	EMPTY = 5,
	ARROWDOWN = 6,
	MINUS = 7,
	PLUS = 8,
	VLINE = 9,
	LCORNER = 10,
	TCORNER = 11,
	BOXPLUS = 12,
	BOXPLUSCONNECTED = 13,
	BOXMINUS = 14,
	BOXMINUSCONNECTED = 15,
	LCORNERCURVE = 16,
	TCORNERCURVE = 17,
	CIRCLEPLUS = 18,
	CIRCLEPLUSCONNECTED = 19,
	CIRCLEMINUS = 20,
	CIRCLEMINUSCONNECTED = 21,
	BACKGROUND = 22,
	DOTDOTDOT = 23,
	ARROWS = 24,
	PIXMAP = 25,
	CHARACTER = 10000
}

local clrWhite = {255,255,255}
local clrBlack = {0,0,0}

editor = {}

-------------
-- Estilos --
-------------
-- Espacios en blanco
SetStyle(0, {fore = {0,0,0} } )
-- Block Comment
SetStyle(1,
	{fore = {255,0,0},
	back = {208,240,240},
	font = { face = "Comic Sans MS", size = 9},
	eolFilled = 1 }
	)
-- Line comment
SetStyle(2,
	{fore = {0,127,0},
	font = { face = "Comic Sans MS", size = 10} }
	)
-- Doc Comment (no se usa en lua)
SetStyle(3,
	{fore = {128,128,0},
	back = {255,0,0} }
	)
-- Number
SetStyle(4,
	{fore = {0,127,127} }
	)	
-- Keywords
SetStyle(5,
	{fore = {0,0,123},
	font = { face = "Verdana", size = 10, bold = 1 } }
	)
-- String
SetStyle(6,
	{fore = {127,0,127} }
	)
-- Character
SetStyle(7,
	{fore = {255,0,0} }
	)
-- Literal string
SetStyle(8,
	{fore = {127,0,127},
	back = {224,255,255},
	font = { face = "Comic Sans MS", size = 9} }
	)
-- Preprocessor (obsoleto desde lua 4)
SetStyle(9,
	{fore = {255,0,255} }
	)
--Operators
SetStyle(10,
	{fore = {0,127,0},
	font = { size = 10 }}
	)
-- Identifier (todo lo dems)
SetStyle(11,
	{fore = {0,0,127} }
	)
-- End of line where string is not closed
SetStyle(12,
	{fore = {0,127,127},
	back = {224,192,224},
	eolFilled = 1}
	)
-- Otras keywords
SetStyle(13,
	{fore = {140,0,0},
	font = { face = "Verdana", size = 10} }
	)

SetStyle(14,
	{fore = {0,0,123},
	font = { face = "Verdana", size = 10, bold = 1 } }
	)
	
SetStyle(15,
	{fore = {140,0,0},
	font = { face = "Verdana", size = 10 } }
	)
	
SetStyle(16,
	{fore = {255,0,0},
	back = {255,208,255}}
	)
	
SetStyle(17,
	{fore = {0,0,127},
	back = {255,255,208}}
	)
	
SetStyle(18,
	{fore = {0,0,127},
	back = {255,160,160}}
	)
	
SetStyle(19,
	{fore = {0,0,127},
	back = {255,208,208}}
	)
-- Default
SetStyle(32,
	{fore = {176,96,255},
	font = { face = "Verdana", size = 8 } }
	)
--Line number
SetStyle(33,
	{fore = {192,192,192},
	font = { face = "Verdana", size = 10 } }
	)
-- Brace highlight
SetStyle(34,
	{fore = {0,0,255},
	font = { face = "Verdana", bold = 1, size = 10 } }
	)
-- Brace incomplete highlight	
SetStyle(35,
	{fore = {255,0,0},
	font = { face = "Verdana", bold = 1, size = 10 } }
	)
--Estilo 36 son los caracteres de control
--Indentation guides
SetStyle(37,
	{fore = {192,192,192},
	back = {255,255,255} }
	)
	

editor.Language = "lua"
editor.Lexer = 15
editor.MatchBraces = 1
editor.HScrollBar = 1
editor.VScrollBar = 1
editor.UndoCollection = 1

--editor.XCaretPolicy = { policy=1, slop=2}
--editor.YCaretPolicy = { policy=1, slop=2}
--editor.VisiblePolicy = { policy=1, slop=2}
--editor.ViewWhiteSpace = 1
--editor.WhiteSpaceFore = {128,128,128}
--editor.WhiteSpaceBack = {128,128,128}
editor.ViewEOL = 0
editor.EOLMode = 0
--editor.SelectionFore = {78,0,0}
--editor.SelectionBack = {255,0,0}
editor.Caret = {
	Fore = {0,0,0},
	Back = {255,255,0},
	LineVisible = 1,
	Period = 500,
	Width = 10
}
editor.HotSpot = {
	Fore = {255,0,0},
	Back = {0,255,0},
	Underline = 1
}
editor.Margins = {
	Margin0 = { Type = 1, Width = 16, Mask = 0, Sensitive = 1 },
	Margin2 = { Type = 0, Width = 16, Mask = -33554432, Sensitive = 1 },
	--Margin2 = { Type = 0, Width = 20 },
	FoldColour = {234,234,234},
	Left = 2,
	Right = 2
}
editor.BufferDraw = 1
editor.TwoPhaseDraw = 1
editor.CodePage = 0
editor.Indentation = {
	UseTabs = 1,
	TabWidth = 8,
	Indent = 5,
	TabIndents = 1,
	BackSpaceUnIndents = 1,
	IndentationGuides = 1,
	AutoIndentation = 1,
	MaintainIndentation = 0,
	StatementStart = {style=5, words="if do else function then" },
	StatementEnd = {style=5, words="end until" },
	BlockStart = {style=10, words="{"},
	BlockEnd = {style=10, words="}"}
}
editor.Markers = {
	{ number = 0, Symbols = 0, Fore = {255,0,0}, Back = {0,0,255}, Pixmap = "" },
	{ number = 1, Symbols = 0, Pixmap = "" },
	{ number = SC_MARKNUM.FOLDEROPEN, Symbols = SC_MARK.MINUS, Fore = clrWhite, Back = clrBlack },
	{ number = SC_MARKNUM.FOLDER, Symbols = SC_MARK.PLUS, Fore = clrWhite, Back = clrBlack },
	{ number = SC_MARKNUM.FOLDERSUB, Symbols = SC_MARK.EMPTY, Fore = clrWhite, Back = clrBlack },
	{ number = SC_MARKNUM.FOLDERTAIL, Symbols = SC_MARK.EMPTY, Fore = clrWhite, Back = clrBlack },
	{ number = SC_MARKNUM.FOLDEREND, Symbols = SC_MARK.EMPTY, Fore = clrWhite, Back = clrBlack },
	{ number = SC_MARKNUM.FOLDEROPENMID, Symbols = SC_MARK.EMPTY, Fore = clrWhite, Back = clrBlack },
	{ number = SC_MARKNUM.FOLDERMIDTAIL, Symbols = SC_MARK.EMPTY, Fore = clrWhite, Back = clrBlack }
}
editor.Folding = {
	Enabled = 1,
	Flags = 16
}

strCompListHnd = "DespacharAccion CFMedioDisponible CrearInstancia EliminarInstancia RaiseEvent"
strCompListObj = "Answer Cancel CerrarFormulario CFCommand CFDeSuscribir CFGetIdentificadorAgente CFGetInstanciaActiva " ..
		"CFHayInstanciaFisicaAsociada CFInstanciarCanal CFMedioDisponible CFQueryCommand CFRecuperarInstancia " ..
		"CFSuscribir CFTestearMedio ChangeState CheckState ChequearPosesionWorkitem CompareIUFF Conference " ..
		"DeleteIUFF Finish FormsShow Get GetIUFF GetPKWhere HangUp HayCampanaAsociada ICFAnswer ICFCommand " ..
		"ICFConference ICFEliminame ICFGetInstanceID ICFHangUp ICFHold ICFPauseRecording ICFQueryCommand ICFRelease ICFResumeRecording " ..
		"ICFSetOwner ICFStartRecording ICFStopRecording ICFTransfer ICFUnhold IHEliminarInstancia IHInteractionEnded " ..
		"NeedToRetryWorkitem Preview QueryForm ReasignarClave ReQueue SendMWEvent SetIUFF Transfer UpdateIUFFFromBR " ..
		"UpdateVariables"
		
strCompListInteractionManager = "NewInstance ModifyInstance DeleteInstance InternalDeleteInstance InternalStateChange"
		
strKeywordsLua = "and break do else elseif end false for function if in local nil not or repeat return then true until while "
strKeywordsLua = strKeywordsLua .. "_VERSION assert collectgarbage dofile error gcinfo loadfile loadstring print tonumber tostring type unpack "
strKeywordsLua = strKeywordsLua .. "_ALERT _ERRORMESSAGE _INPUT _PROMPT _OUTPUT _STDERR _STDIN _STDOUT call dostring foreach foreachi getn globals newtype rawget rawset require sort tinsert tremove "
strKeywordsLua = strKeywordsLua .. "abs acos asin atan atan2 ceil cos deg exp floor format frexp gsub ldexp log log10 max min mod rad random randomseed sin sqrt strbyte strchar strfind strlen strlower strrep strsub strupper tan "
strKeywordsLua = strKeywordsLua .. "openfile closefile readfrom writeto appendto remove rename flush seek tmpfile tmpname read write clock date difftime execute exit getenv setlocale time "		

strMisKeywords = strCompListHnd .. " " .. strCompListObj .. " " .. strCompListInteractionManager  -- estas son del tipo obj:, hnd: o interactionManager:
strMisKeywords2 = "BRAddCondition BRCheckAttrInstancia BRDeleteCondition BRDeleteInstancia BRGetAttrInstancia BRResetConditions "	-- estas son sueltas, tipo LogMsg
strMisKeywords2 = strMisKeywords2 .. "Confirm ExecuteCOM ExecutePeticion FormsShow GetCurrentUser GetPKWhere GetUserCountry "
strMisKeywords2 = strMisKeywords2 .. "LogMsg MsgBox ObtenerIDUnico RaiseEvent QueryForm UpdateIUFFFromBR UpdateVariables "
strMisKeywords2 = strMisKeywords2 .. "GetGlobalIUFF SetGlobalIUFF"

editor.Keywords = {
	0, strKeywordsLua,
	1, strMisKeywords,
	2, strMisKeywords2,
	3, "obj hnd interactionManager"}-- si quiero agregar ms, sera ej: {0, string, 1, string, 2, string}

editor.AutoCompletion = {
	AutoHide = 0,
	CancelAtStart = 1,
	ChooseSingle = 1,
	DropRestOfWord = 1,
	IgnoreCase = 1,
	Separator = ' ',
	SeparatorType = '?',
	--FillUps = "("
}

editor.CompletionList = {
	{ Prefix = "obj",
	  Wordlist = {	{"Answer"},
			{"Cancel"},
			{"CerrarFormulario"},
			{"CFCommand", "command, [parameter list]"},
			{"CFDeSuscribir"},
			{"CFGetIdentificadorAgente"},
			{"CFGetInstanciaActiva"},
			{"CFHayInstanciaFisicaAsociada"},
			{"CFInstanciarCanal", "[parameter list]"},
			{"CFMedioDisponible"},
			{"CFQueryCommand"},
			{"CFRecuperarInstancia", "[parameter list]"},
			{"CFSuscribir", "value"},
			{"CFTestearMedio"},
			{"ChangeState", "state name"},
			{"CheckState", "state name"},
			{"ChequearPosesionWorkitem"},
			{"CompareIUFF", "iuff, value"},
			{"Conference"},
			{"DeleteIUFF", "iuff"},
			{"Finish"},
			{"FormsShow", "form name"},
			{"Get"},
			{"GetIUFF", "name"},
			{"GetPKWhere"},
			{"HangUp"},
			{"HayCampanaAsociada"},
			{"ICFAnswer", "[parameter list]"},
			{"ICFCommand", "command, [parameter list]"},
			{"ICFConference", "[parameter list]"},
			{"ICFEliminame"},
			{"ICFGetInstanceID"},
			{"ICFHangUp", "[parameter list]"},
			{"ICFHold"},
			{"ICFPauseRecording"},
			{"ICFQueryCommand"},
			{"ICFRelease"},
			{"ICFResumeRecording"},
			{"ICFSetOwner"},
			{"ICFStartRecording"},
			{"ICFStopRecording"},
			{"ICFTransfer", "[parameter list]"},
			{"ICFUnhold"},
			{"IHEliminarInstancia"},
			{"IHInteractionEnded"},
			{"NeedToRetryWorkitem"},
			{"Preview"},
			{"QueryForm", "form name"},
			{"ReasignarClave", "old key, new key"},
			{"ReQueue"},
			{"SendMWEvent", "event, [parameter name, value, ...]"},
			{"SetIUFF", "name, value"},
			{"Transfer"},
			{"UpdateIUFFFromBR", "iuff"},
			{"UpdateVariables", "IML"}
		     }
	},
	{ Prefix = "hnd",
	  Wordlist = {	{"DespacharAccion", "method name"},
			{"CFMedioDisponible"},
			{"CrearInstancia"},
			{"EliminarInstancia"},
			{"RaiseEvent", "event name"}
		     }
	},
	{ Prefix = "interactionManager",
	  Wordlist = {
		{"NewInstance", "instanceID, [workitemType, interactionState, actorID ]"},
		{"ModifyInstance", "instanceID, [workitemType, interactionState, actorID ]"},
		{"DeleteInstance", "instanceID, [workitemType, interactionState, actorID ]"},
		{"InternalDeleteInstance", "instanceID, [workitemType, interactionState]"},
		{"InternalStateChange", "instanceID, newInternalState"},
	  }
	},
	{ Prefix = "",
	  Wordlist = {	{"BRAddCondition", "condition"},
	  		{"BRCheckAttrInstancia", "pkwhere, attribute, value"},
	  		{"BRDeleteCondition", "identifier"},
	  		{"BRDeleteInstancia", "pkwhere"},
	  		{"BRGetAttrInstancia", "pkwhere, attribute"},
			{"BRResetConditions"},
			{"Confirm", "Title, Text"},
			{"ExecuteCOM", "progID, method, parameter list"},
			{"ExecutePeticion", "petition, version, matrix, parameter list"},
			{"GetCurrentUser"},
			{"GetUserCountry"},
			{"LogMsg", "Format, [parameter list]"},
			{"MsgBox", "Title, Text"},
			{"ObtenerIDUnico"},
			{"ThrowException", "type, origin, description"},
			{"SetGlobalIUFF", "name, value"},
			{"GetGlobalIUFF", "name2"}
		     }
	}
}
