#include "stdafx.h"
#include "compintdesigner.h"
#include "rolesview.h"
#include "Domain\Globales.h"
#include "Domain\ModelManager.h"
#include "MainFrm.h"
#include "RolesWkitemsTree.h"
#include "Domain\Rol.h"
#include "Domain\DefWorkitem.h"
#include "ViewCommand.h"
#include "FolderBrowser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRolesView

IMPLEMENT_DYNCREATE(CRolesView, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CRolesView, CMDIChildWnd)
	//{{AFX_MSG_MAP(CRolesView)
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	ON_COMMAND(ID_WK_EDIT_CURRENT_CODE, OnClickEditCode)
	ON_COMMAND(ID_WK_EXPORT_ALL_TO_XML, OnClickExportAllToXML)
	ON_COMMAND(ID_WK_EXPORT_ALL_TO_SQL, OnClickExportAllToSQL)
	ON_WM_CONTEXTMENU()
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CRolesView::CRolesView() {}

CRolesView::~CRolesView() {}


/////////////////////////////////////////////////////////////////////////////
// 
BOOL CRolesView::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) {
	TVisualObject* pView = new TVisualObject(1, pContext, RUNTIME_CLASS(CRolesWkitemsTree));
	
	// Add all visual objects to the framework
	m_Framework.Add(pView);

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_WORKITEMS))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SetFullColorImage(24, 24, IDR_WORKITEMS, RGB(255, 0, 255));

	if(!m_Framework.Create(this)) {
		return FALSE;
	}
	m_objWkitemsTree = (CRolesWkitemsTree*)(pView->GetWnd());
	m_wndToolBar.EnableToolTips();
	EnableToolTips();
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CRolesView message handlers

//////////////////////////////////////////////////////////////////////
// 
void CRolesView::OnDestroy() {
	CMDIChildWnd::OnDestroy();
	m_Framework.Destroy();
}

//////////////////////////////////////////////////////////////////////
// 
void CRolesView::OnClose()  {
	((CMainFrame*)GetParentFrame())->OnWindowClosing(this);
	CMDIChildWnd::OnClose();
}

//////////////////////////////////////////////////////////////////////
// 
void CRolesView::OnClickExportAllToXML() {
	// Recorro cada rol
	// Por cada rol, recorro sus workitems
	// Por cada workitem, genero un archivo XML
	CWaitCursor waitCursor;

	CMyMapIterador<CRol*>* mapaRoles;
	mapaRoles = g_objModelManager->GetRoles();

	if(!mapaRoles->begin()) {
		delete mapaRoles;
		return;
	}

	CFolderBrowser folderBrowser;
	CString pathName;
	folderBrowser.RemeberSelected();
	folderBrowser.PreSelectLastUsedFolder();
	if(!folderBrowser.Show(this->m_hWnd, pathName)) {
		delete mapaRoles;
		return;
	}

	while(*mapaRoles) {
		CRol* rol = (*mapaRoles)++;
		CMyMapIterador<stWkiRol*>* mapaWkis = rol->GetWorkitems();
		if(mapaWkis->begin()) {
			while(*mapaWkis) {
				stWkiRol* workitem_rol = (*mapaWkis)++;
				CDefWorkitem* definicionWorkitem;
				ModelLoadResult res = g_objModelManager->LoadFromBD(workitem_rol->m_strWkiID, rol->GetID(), &definicionWorkitem);
				switch(res) {
					case RES_OK: {
						CString scriptFullPath = pathName;
						scriptFullPath += "\\";
						scriptFullPath += definicionWorkitem->GetTipo();
						scriptFullPath += ".xml";
						if(!g_objModelManager->SaveIntoXML(scriptFullPath, definicionWorkitem)) {
							CString strTemp;
							strTemp.Format(IDS_ERROR_WRITING_FILE, scriptFullPath);
							AfxMessageBox(strTemp, MB_ICONERROR);
						}
						delete definicionWorkitem;
					break;}
					case FAIL_CANT_UNCOMPRESS:
						AfxMessageBox("Couldn't uncompress the workitem's code.", MB_ICONERROR);
					break;
					case FAIL_WRONG_XML:
						AfxMessageBox("The workitem's code is not a well formed XML.", MB_ICONERROR);
					break;
					case FAIL_DATABASE_ERROR:
						AfxMessageBox("Error connecting to the database.", MB_ICONERROR);
					break;
				}
			}
		}
		delete mapaWkis;
	}
	delete mapaRoles;
}

//////////////////////////////////////////////////////////////////////
/// Toma cada workitem y genera el script SQL correspondiente
void CRolesView::OnClickExportAllToSQL() {
	// Recorro cada rol
	// Por cada rol, recorro sus workitems
	// Por cada workitem, genero un script sql
	CWaitCursor waitCursor;

	CMyMapIterador<CRol*>* mapaRoles;
	mapaRoles = g_objModelManager->GetRoles();

	if(!mapaRoles->begin()) {
		delete mapaRoles;
		return;
	}

	CFolderBrowser folderBrowser;
	CString pathName;
	folderBrowser.RemeberSelected();
	folderBrowser.PreSelectLastUsedFolder();
	if(!folderBrowser.Show(this->m_hWnd, pathName)) {
		delete mapaRoles;
		return;
	}

	while(*mapaRoles) {
		CRol* rol = (*mapaRoles)++;
		CMyMapIterador<stWkiRol*>* mapaWkis = rol->GetWorkitems();
		if(mapaWkis->begin()) {
			while(*mapaWkis) {
				stWkiRol* workitem_rol = (*mapaWkis)++;
				CDefWorkitem* definicionWorkitem;
				ModelLoadResult res = g_objModelManager->LoadFromBD(workitem_rol->m_strWkiID, rol->GetID(), &definicionWorkitem);
				switch(res) {
					case RES_OK: {
						CString scriptFullPath = pathName;
						scriptFullPath += "\\";
						scriptFullPath += definicionWorkitem->GetTipo();
						scriptFullPath += ".sql";
						if(!g_objModelManager->SaveIntoSQL(scriptFullPath, definicionWorkitem->GetTipo(), workitem_rol->m_strRolID, definicionWorkitem)) {
							CString strTemp;
							strTemp.Format(IDS_ERROR_WRITING_FILE, scriptFullPath);
							AfxMessageBox(strTemp, MB_ICONERROR);
						}
						delete definicionWorkitem;
					break;}
					case FAIL_CANT_UNCOMPRESS:
						AfxMessageBox("Couldn't uncompress the workitem's code.", MB_ICONERROR);
					break;
					case FAIL_WRONG_XML:
						AfxMessageBox("The workitem's code is not a well formed XML.", MB_ICONERROR);
					break;
					case FAIL_DATABASE_ERROR:
						AfxMessageBox("Error connecting to the database.", MB_ICONERROR);
					break;
				}
			}
		}
		delete mapaWkis;
	}
	delete mapaRoles;
}

//////////////////////////////////////////////////////////////////////
/// 
void CRolesView::OnClickEditCode() {
	CWaitCursor waitCursor;
	stWkiRol* workitem_rol;
	CRol* rol;

	if(!GetSelectedRolAndWorkitem(&rol, &workitem_rol)) {
		return;
	}
	CDefWorkitem* objDefWki;
	ModelLoadResult res = g_objModelManager->LoadFromBD(workitem_rol->m_strWkiID, rol->GetID(), &objDefWki);
	switch(res) {
		case RES_OK:
			((CMainFrame*)(GetParentFrame()))->AddWorkitemPane(objDefWki, workitem_rol);
		break;
		case FAIL_CANT_UNCOMPRESS:
			AfxMessageBox(_T("Couldn't uncompress the workitem's code."), MB_ICONERROR);
		break;
		case FAIL_WRONG_XML:
			AfxMessageBox(_T("The workitem's code is not a well formed XML."), MB_ICONERROR);
		break;
		case FAIL_DATABASE_ERROR:
			AfxMessageBox(_T("Error connecting to the database."), MB_ICONERROR);
		break;
		case WARNING_EMPTY_WORKITEM:
			((CMainFrame*)(GetParentFrame()))->AddWorkitemPane(objDefWki, workitem_rol);
		break;
	}
}

//////////////////////////////////////////////////////////////////////
/// Retorna el Rol y el Workitem correspondiente al nodo del rbol 
/// actualmente seleccionado
bool CRolesView::GetSelectedRolAndWorkitem(CRol** p_objRol, stWkiRol** p_objWki) {
	CTreeCtrl& treeControl = m_objWkitemsTree->GetTreeCtrl();
	HTREEITEM hDev = treeControl.GetSelectedItem();
	
	if(!hDev) {
		return false;
	}
	if(treeControl.GetChildItem(hDev)) {
		// Si no es una hoja, me voy
		return false;
	}
	HTREEITEM hDevRol;
	hDevRol = treeControl.GetParentItem(hDev);
	*p_objRol = (CRol*)treeControl.GetItemData(hDevRol);
	*p_objWki = (stWkiRol*)treeControl.GetItemData(hDev);
	return true;
}

//////////////////////////////////////////////////////////////////////
// 
BOOL CRolesView::OnDataUpdate(CViewCommand* p_Command) {
	switch(p_Command->GetCommandType()) {
		case COMMAND_WORKITEM_APPLY_CHANGES: {
			stWkiRol* objWkiRol = (stWkiRol*)p_Command->GetData();
		break;}

		case COMMAND_UPDATE_ROLES: {
			CViewCommand pComm(COMMAND_UPDATE_ALL);
			m_objWkitemsTree->OnDataUpdate(&pComm);
		}
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// 
void CRolesView::OnContextMenu(CWnd* pWnd, CPoint point) {
	CMenu menu;
	CTreeCtrl& treeControl = m_objWkitemsTree->GetTreeCtrl();
	// fix - on right click, we also want to change the current selection like the left click does 
	CPoint p = point;
	treeControl.ScreenToClient(&p);
	HTREEITEM htItem = treeControl.HitTest(p);
	if(htItem) {
		treeControl.SelectItem(htItem);
	}
	// fix end 
	menu.CreatePopupMenu();
	menu.AppendMenu(MF_STRING, ID_WK_EDIT_CURRENT_CODE, _T("Edit Code"));
	
	menu.TrackPopupMenu(TPM_LEFTALIGN, point.x, point.y, this);
}

//////////////////////////////////////////////////////////////////////////
///
void CRolesView::OnLButtonDblClk(UINT nFlags, CPoint point) {
	OnClickEditCode();
	CMDIChildWnd::OnLButtonDblClk(nFlags, point);
}
